/* By  Antti-Pekka.Tuovinen@cs.helsinki.fi */

package CH.ifa.draw.contrib;

import CH.ifa.draw.standard.*;
import java.awt.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.util.Geom;

/**
 * A ChopDiamondConnector locates connection points by
 * choping the connection between the centers of the
 * two figures at upright triangle perimeter.
 * @see Connector
 */
public class ChopDownTriangleConnector extends ChopBoxConnector {

    public ChopDownTriangleConnector() { // only used for Storable implementation
    }

    public ChopDownTriangleConnector(Figure owner) {
        super(owner);
    }


    protected Point chop(Figure target, Point from) {
        Rectangle r = target.displayBox();
        double angle = Geom.pointToAngle(r, from);
	    return DiamondGeom.downTriangleAngleToPoint(r, angle);
    }
}