/* By Antti-Pekka.Tuovinen@cs.helsinki.fi 

   This is mostly code from CH.ifa.draw.figures.EllipseFigure.java
   except for the drawBackGround and drawFrame -methods. Could not
   figure out the serialization support, though.
*/

package CH.ifa.draw.contrib;

import java.awt.*;
import java.io.IOException;
import java.util.Vector;
import CH.ifa.draw.util.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;

/**
 * A diamond figure.
 */
public class Diamond2Figure extends AttributeFigure {

    private Rectangle   fDisplayBox;

    /*
     * Serialization support.
     */
    //private static final long serialVersionUID = -6856203289355118951L;
    //private int ellipseFigureSerializedDataVersion = 1;

    public Diamond2Figure() {
        this(new Point(0,0), new Point(0,0));
    }

    public Diamond2Figure(Point origin, Point corner) {
        basicDisplayBox(origin,corner);
    }

    public Vector handles() {
        Vector handles = new Vector();
        BoxHandleKit.addHandles(this, handles);
        return handles;
    }

    public void basicDisplayBox(Point origin, Point corner) {
        fDisplayBox = new Rectangle(origin);
        fDisplayBox.add(corner);
    }

    public Rectangle displayBox() {
        return new Rectangle(
            fDisplayBox.x,
            fDisplayBox.y,
            fDisplayBox.width,
            fDisplayBox.height);
    }

    public void basicMoveBy(int x, int y) {
        fDisplayBox.translate(x,y);
    }

    public void drawBackground(Graphics g) {
        Rectangle r = displayBox();
	int xPoints[] = {r.x,r.x+r.width/2,r.x+r.width,r.x+r.width/2};
	int yPoints[] = {r.y+r.height/2,r.y+r.height,r.y+r.height/2,r.y};
        g.setColor(getFillColor());
        g.fillPolygon(xPoints,yPoints,4);
    }

    public void drawFrame(Graphics g) {
        Rectangle r = displayBox();
	int xPoints[] = {r.x,r.x+r.width/2,r.x+r.width,r.x+r.width/2};
	int yPoints[] = {r.y+r.height/2,r.y+r.height,r.y+r.height/2,r.y};
        g.setColor(getFrameColor());
        g.drawPolygon(xPoints,yPoints,4);
    }

    public Insets connectionInsets() {
        Rectangle r = fDisplayBox;
        int cx = r.width/2;
        int cy = r.height/2;
        return new Insets(cy, cx, cy, cx);
    }

    public Connector connectorAt(int x, int y) {
        return new ChopDiamondConnector(this);
    }

    public void write(StorableOutput dw) {
        super.write(dw);
        dw.writeInt(fDisplayBox.x);
        dw.writeInt(fDisplayBox.y);
        dw.writeInt(fDisplayBox.width);
        dw.writeInt(fDisplayBox.height);
    }

    public void read(StorableInput dr) throws IOException {
        super.read(dr);
        fDisplayBox = new Rectangle(
            dr.readInt(),
            dr.readInt(),
            dr.readInt(),
            dr.readInt());
    }
}