

package CH.ifa.draw.contrib;

import java.awt.*;
import java.util.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.standard.*;

/**
 * an EllipseFigure which cannot be resized.
 */
abstract public class FixedSizeEllipse extends EllipseFigure {

    public FixedSizeEllipse(Point origin,Point corner) {
        super(origin,corner);
    }

    public FixedSizeEllipse() {
        super();
    }

	/** A hook to specify the size of this. Make this a small circle by default. */
	protected Point getExtension() {
		return new Point(10,10);
	}

  /** Set the displayBox of this keeping the specified size. */
	public void displayBox(Point origin, Point corner) {
		Point ext = getExtension();
        super.displayBox(
        	origin, 
        	new Point(origin.x+ext.x,origin.y+ext.y)
        );
    }

    /** Returns a set of NullHandles. */
    public Vector handles() {
        Vector handles = new Vector();
      	handles.addElement(new NullHandle(this, RelativeLocator.southEast()));
        handles.addElement(new NullHandle(this, RelativeLocator.southWest()));
        handles.addElement(new NullHandle(this, RelativeLocator.northEast()));
        handles.addElement(new NullHandle(this, RelativeLocator.northWest()));
        return handles;
    }
}