package CH.ifa.draw.contrib.xcomp;

import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import java.awt.*;
import java.util.*;
import java.io.*;
import com.objectspace.jgl.algorithms.Sorting;
import com.objectspace.jgl.*;
import com.objectspace.jgl.adapters.VectorArray;
import com.objectspace.jgl.predicates.BinaryNot;

/**
 * The basic implementation for list-like layout strategies.
 * Like BagLayout this layout manager positions the contained
 * figures 'as they were'. That is, no positioning is performed.
 * This is an example implementation that shows how the mechanisms
 * of super classes are used to create specialized layout managers.
 */ 

public class BagFlowLayout2 extends BagFlowLayout {

	public BagFlowLayout2() {
		super();
	}

	/**
	 * Positions the minimum size rectangle
	 * flush to the edge or corner furthest away from the manipulator.
	 */
	public void overlayMinimumRectangle(CompositeFigure container,Rectangle minimum) {
			Handle manip = container.getManipulator();
			if (manip == null) {
				
			} else if (manip instanceof SouthHandle) {
				
			} else if (manip instanceof SouthWestHandle) {
				minimum.translate(container.displayBox().width - minimum.width,0);
			} else if (manip instanceof WestHandle) {
				minimum.translate(container.displayBox().width - minimum.width,0);
			} else if (manip instanceof NorthWestHandle) {
				minimum.translate(
					container.displayBox().width - minimum.width,
					container.displayBox().height - minimum.height
				);
			} else if (manip instanceof NorthHandle) {
				minimum.translate(0,container.displayBox().height - minimum.height);
			} else if (manip instanceof NorthEastHandle) {
				minimum.translate(0,container.displayBox().height - minimum.height);
			} else if (manip instanceof EastHandle) {
			
			} else if (manip instanceof SouthEastHandle) {
			
			} 		
	}
}