

package CH.ifa.draw.figures;

import java.awt.*;
import java.util.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;

/**
 * An ellipse that can be used as the physical frame figure 
 * of an owning FrameComposite. 
 */
public class RootEllipseFigure 
	extends EllipseFigure
	implements RootFigure {
	
	Figure fComposite;
	
	public RootEllipseFigure(Figure composite) {
		super();
		fComposite = composite;
	}

	public RootEllipseFigure(Point origin, Point corner,
	                           Figure composite) {
		super(origin,corner);
		fComposite = composite;
	}

  /**
   * Returns standard box handles for the composite.
   */
    public Vector handles() {
        Vector handles = new Vector();
        BoxHandleKit.addHandles(fComposite, handles);
        return handles;
    }

  /**
   * Returns a standard ChopBoxConnector for the composite.
   */
    public Connector connectorAt(int x, int y) {
        return new ChopEllipseConnector(fComposite);
    }


  /** A hook - no mimimum size by default. */
    
	public Dimension getMinimumSize() {
		return null;
    //return new Point(20,20);
	}

  /**
   * Calls willChange() of the composite prior to setting the display box and
   * changed() afterwards.
   */
    public void displayBox(Point origin, Point corner) {
        fComposite.willChange();
        super.displayBox(origin, corner);
        fComposite.changed();
    }
}