/*
 * @(#)RootRoundRectangleFigure.java
 *
 */


package CH.ifa.draw.figures;


import java.awt.*;
import java.util.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.standard.*;

/**
 * A rounded rectangle that can be used as the physical frame figure 
 * of an owning FrameComposite. 
 */

public class RootRoundRectangleFigure 
	extends RoundRectangleFigure
	implements RootFigure {

	Figure fComposite;
	
	public RootRoundRectangleFigure(Figure composite) {
		super();
		fComposite = composite;
	}

	public RootRoundRectangleFigure(Point origin, Point corner,
	                                Figure composite) {
		super(origin,corner);
		fComposite = composite;
	}
	
  /**
   * Returns standard box handles for the composite.
   */
    public Vector handles() {
        Vector handles = new Vector();
        BoxHandleKit.addHandles(fComposite, handles);
        return handles;
    }

  /**
   * Returns a standard ChopBoxConnector for the composite.
   */
    public Connector connectorAt(int x, int y) {
        return new ChopBoxConnector(fComposite); // just for demo purposes
    }


    // hook - no mimimum size by default
    
  /** Returns a dimension of 3 by 3. */
	public Dimension getMinimumSize() {
		return new Dimension(3,3);
	}

  /**
   * Calls willChange() of the composite prior to setting the display box and
   * changed() afterwards.
   */
    public void displayBox(Point origin, Point corner) {
        fComposite.willChange();
        super.displayBox(origin, corner);
        fComposite.changed();
    }
}