

package CH.ifa.draw.framework;

/**
 * An Alignable figure has an associated Aligner object for positioning
 * the figure. With aligners, a composite can maintain a layout of subfigures.
 */
public interface Alignable {

  /**
   * Set the aligner associated with this.
   */
  void setAligner(Aligner aligner);

  /**
   * Get the aligner associated with this.
   */
  Aligner getAligner();
} 