

package CH.ifa.draw.framework;

import java.awt.Point;
import java.io.*;

/**
 * Aligner is a strategy class that encapsulates an alignment algorithm.
 * for absolute positioning of subfigures within figure holders.
 */

public interface Aligner extends Serializable {

  /**
   * Align (or position) the child within its holder (the context object).
   * Returns a point representing the absolute position of the origin of
   * the child.
   */
  public Point align(Figure child);
} 