/*
 * @(#)DropTarget
 *
 */

package CH.ifa.draw.framework;

/**
 * Figures indicate whether other figures can be dropped onto them
 * by implementing this interface. A DropTarget can refuse drops
 * selectively based on the properties (or types) of dropped Figures.
 */

 public interface DropTarget {

    /**
     * Returns true if figure can be dropped onto this.
     */
    boolean accept(Figure figure);

    /**
     * Drop a figure onto this.
     * @param the figure to drop
     * @return the dropped Figure
     */
    Figure drop(Figure figure);
} 