/*
 * @(#)FigureSelection.java 5.1
 *
 */

package CH.ifa.draw.framework;

import CH.ifa.draw.util.*;
import java.util.*;
import java.io.*;

/**
 * FigureSelection enables to transfer the selected figures
 * to a clipboard.<p>
 * Will soon be converted to the JDK 1.1 Transferable interface.
 *
 * @see Clipboard
 */

public class FigureSelection extends Object {

    private byte[] fData; // flattend figures, ready to be resurrected
    /**
     * The type identifier of the selection.
     */
    public final static String TYPE = "CH.ifa.draw.Figures";

    /**
     * Constructes the Figure selection for the vecotor of figures.
     */
    public FigureSelection(Vector figures) {
        // a FigureSelection is represented as a flattened ByteStream
        // of figures.
        //System.err.println(figures);
        try {
        ByteArrayOutputStream output = new ByteArrayOutputStream(200);
        ObjectOutput output2 = new ObjectOutputStream(output);
        output2.writeObject(figures);
        /*Enumeration selected = figures.elements();
        while (selected.hasMoreElements()) {
            Figure figure = (Figure) selected.nextElement();
            output2.writeObject(figure);
        }
        */
        output2.close();
       /*
        StorableOutput writer = new StorableOutput(output);
        writer.writeInt(figures.size());
        Enumeration selected = figures.elements();
        while (selected.hasMoreElements()) {
            Figure figure = (Figure) selected.nextElement();
            writer.writeStorable(figure);
        }
        writer.close();
        */
        fData = output.toByteArray();
        } catch (IOException e) {
        	System.err.println("FigureSelection: "+e.toString());	
        }
    }

    /**
     * Gets the type of the selection.
     */
    public String getType() {
        return TYPE;
    }

    /**
     * Gets the data of the selection. The result is returned
     * as a Vector of Figures.
     *
     * @return a copy of the figure selection.
     */
    public Object getData(String type) {
        if (type.equals(TYPE)) {
        		Vector result = null;
          	try {
						InputStream input = new ByteArrayInputStream(fData);
						ObjectInput input2 = new ObjectInputStream(input);
            result = (Vector)input2.readObject();
            } catch (IOException e) {
                System.out.println(e.toString());
            } catch (ClassNotFoundException e) {
                System.out.println(e.toString());
            }

            return result;
        }
        return null;
    }
}