

package CH.ifa.draw.framework;

import CH.ifa.draw.contrib.xcomp.LabelPanel;

/**
 * A LabelledSegment has methods for accessing the labels associated with it
 * and for merging with another segment. The labels are accessed by consecutive
 * integers in the range [first(),last()].
 */
public interface LabelledSegment {

  /** Sets the relative position in the owner connection. */
  public void setSegment(int segment);

  /** Gets the label holder at position index. */
  public LabelPanel getLabelAt(int index);

  /** Sets the label holder at position index to label.*/
  public void setLabelAt(LabelPanel label,int index);

  /** Creates a label holder at position index. */
  public void createLabelAt(int index);

  /** Merges the contents of the label holders (the actual figures used as labels)
   * of segment other with the label holders of this.
   */
  public void merge(LabelledSegment other);

  /** Gets the index of the first label holder of this. */
  public int first();

  /** Gets the index of the last label holder of this. */
  public int last();
}