
package CH.ifa.draw.samples.classdiagram;



import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.contrib.xcomp.*;
import CH.ifa.draw.samples.classdiagram.work.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


//public class State extends StructuredCompositeFigure {
public class ClassBox extends FrameComposite {


  public ClassBox() {
    super();
  }
  public ClassBox(Point origin, Point corner) {
    super(origin,corner);
  }

  /**
   * Creates a RootRoundRectangleFigure.
   */
  protected RootFigure createRootFigure(){
    return new RootRectangleFigure(this);
  }

  /**
   * Creates a RootRoundRectangleFigure.
   */
  protected RootFigure createRootFigure(Point origin, Point corner) {
    return new RootRectangleFigure(origin,corner,this);
  }
  
  /**
   * Creates the default state compartment for this super state.
   */
  public void created() {
 		if (figureCount() == 0)
 			super.add(
				new NameCompartment(displayBox().getLocation(),new Point(0,0))
			);
 }


  protected DrawLayoutManager getDefaultLayoutManager() {
   	//return new BagFlowLayout();
   	//return new VListLayout();
   	//return new VListCenteringLayout();
   	//return new SuperStateLayout(2);
  	return new ClassBoxLayout();
  } 

	public Insets getInsets() {
		return new Insets(5,3,5,3);
	}
	
	public boolean accept(Figure figure) {
		if (figureCount() == 0)
			return true;
		if (   (figure instanceof OperationCompartment)
			   ||(figure instanceof NameCompartment)
			   ||(figure instanceof AttributeCompartment)
			 ) 
			return true;
		return false;
	}
	


  /**
   * Draws a horizontal solid line after each name compartment and a
   * vertical dashed line after each state machine compartment (except the
   * last).
   */
	public void drawDividers(Graphics g) {
		//System.err.println("drawdividers");
		Vector compartments = ((VListLayout)getLayout()).getComponents();
 		for (int i = 0;i < compartments.size()-1;i++) {
 			Rectangle r =((Figure)compartments.elementAt(i)).displayBox();
 			//System.err.println("drawDividers: "+i+" "+r);
      //if ((compartments.elementAt(i) instanceof NameCompartment) ||
      //	  (compartments.elementAt(i) instanceof ITCompartment))
      g.drawLine(r.x,r.y+r.height,r.x+r.width-1,r.y+r.height);
      //else
      //  RenderingTool
      //    .drawDashedLine(g,r.x,r.y+r.height,r.x+r.width,r.y+r.height-1,4);
 		}
  }

	public Figure add(Figure figure) {
		if (figureCount() == 0 && !(figure instanceof Compartment)) {
			NameCompartment c =
					(NameCompartment)super.add(
						new NameCompartment(displayBox().getLocation(),new Point(0,0))
					);
			if (!((figure instanceof NameCompartment) || 
				    (figure instanceof AttributeCompartment) ||
				    (figure instanceof OperationCompartment)))
				return c.add(figure);
		}
		return super.add(figure);
	}
	
	public Figure remove(Figure figure) {
		super.remove(figure);	
		
		// if the remaining compartments are all name compartments,
		// creates a new state compartment.
	/*	Vector compartments = ((SuperStateLayout)getLayout()).getComponents();
		boolean allNames = true;
		int i = 0;
		while (allNames && i < compartments.size()) {
			if (compartments.elementAt(i) instanceof StateCompartment)
				allNames = false;
			i++;
		}
		if (allNames) 
			super.add(
				new StateCompartment(displayBox().getLocation(),new Point(0,0))
			); */
		return figure;
	}
    /**
     * Draws all the contained figures. Calls drawDividers() (this is a template
     * method).
     * @see Figure#draw
     */
  public void draw(Graphics g) {
    Shape clip = g.getClip();
	  Rectangle r = displayBox();
    g.clipRect(r.x,r.y,r.width,r.height);
    super.draw(g);
    drawDividers(g);
    g.setClip(clip);
  }
 
}