package CH.ifa.draw.samples.classdiagram;

import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.contrib.xcomp.*;
import java.awt.*;
import java.util.*;
import java.io.*;
import com.objectspace.jgl.algorithms.Sorting;
import com.objectspace.jgl.algorithms.Copying;

import com.objectspace.jgl.*;
import com.objectspace.jgl.adapters.VectorArray;
import com.objectspace.jgl.predicates.BinaryNot;

/**
 * The basic implementation for list-like layout strategies.
 * Like BagLayout this layout manager positions the contained
 * figures 'as they were'. That is, no positioning is performed.
 * This is an example implementation that shows how the mechanisms
 * of super classes are used to create specialized layout managers.
 */ 

// make superstatelayout maintain a logical order of compartments:
// name compartments on the top!

public class ClassBoxLayout extends VTiledLayout {

	public ClassBoxLayout() {
		super();
	}
	
	public ClassBoxLayout(int hgap) {
		super(hgap);
	}
	
	

	protected Vector getNameCompartments() {
		Vector names = new Vector();
		for (int i=0;i<fComponents.size();i++)
			if (fComponents.elementAt(i) instanceof NameCompartment)
				names.addElement(fComponents.elementAt(i));
		return names;
	}
	
	protected Vector getAttributeCompartments() {
		Vector names = new Vector();
		for (int i=0;i<fComponents.size();i++)
			if (fComponents.elementAt(i) instanceof AttributeCompartment)
				names.addElement(fComponents.elementAt(i));
		return names;
	}

	protected Vector getOperationCompartments() {
		Vector states = new Vector();
		for (int i=0;i<fComponents.size();i++)
			if (fComponents.elementAt(i) instanceof OperationCompartment)
				states.addElement(fComponents.elementAt(i));
		return states;
	}
	
	protected void attachAligners() {
		Vector names = getNameCompartments();
		Vector attribs = getAttributeCompartments();
		Vector ops = getOperationCompartments();
  	Sorting.sort(
  		new VectorArray(names),
  		new BinaryNot(getOrderingPredicate())
  	);
   	Sorting.sort(
  		new VectorArray(attribs),
  		new BinaryNot(getOrderingPredicate())
  	);
 		Sorting.sort(
  		new VectorArray(ops),
  		new BinaryNot(getOrderingPredicate())
  	);
  	fComponents.removeAllElements();
		Copying.copy(new VectorArray(names),new VectorArray(fComponents));
		Copying.copy(new VectorArray(attribs),new VectorArray(fComponents));
		Copying.copy(new VectorArray(ops),new VectorArray(fComponents));
		//super.attachAligners();
  }

	
}