package CH.ifa.draw.samples.classdiagram;

/*
 * @(#)NameCompartment.java
 */

import CH.ifa.draw.standard.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.contrib.xcomp.*;
import java.awt.*;
import java.util.*;
import com.objectspace.jgl.Pair;
import com.objectspace.jgl.HashMap;
import java.io.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.samples.classdiagram.work.*;
import CH.ifa.draw.samples.classdiagram.stringparser.*;
	
public class NameCompartment extends Compartment implements ContentsChangeListener {

    protected Hashtable figureProperties;
    
    public NameCompartment() {
      this(new Point(0,0),new Point(0,0));
    }

    public NameCompartment(Point origin, Point corner) {
      super(origin,corner);
      figureProperties = new Hashtable();
    }
    
	public boolean accept(Figure figure) {
		if (figure instanceof FigurePanel) 
			return false;
		return true;
	}
	
	public Figure add(Figure figure) {
		if (!figureProperties.containsKey(figure)) {
			figureProperties.put(figure,figure.getAttribute("FontStyle"));
			if (figure instanceof UMLTextFigure) {
				setTextStyle((UMLTextFigure)figure);
				((UMLTextFigure)figure).addContentsListener(this);
			}
		}
		return super.add(figure);
	}
	
	public void contentsChanged(ContentsChangedEvent e) {
		Figure figure = e.getFigure();
		if (figure instanceof UMLTextFigure) 
			setTextStyle((UMLTextFigure)figure);
	}
	
	private void setTextStyle(UMLTextFigure umlText) {
		String text = umlText.getText();
		//System.err.println("*"+text+"*");
		//UMLStringRecognizer parser = UMLStringRecognizer.getUMLStringRecognizer();
		int string = UMLStringRecognizer.getUMLStringRecognizer().parseUMLString(text);
		//System.err.println(new Integer(string));
		//System.err.println((string == UMLStringRecognizer.NAME));
		if (string == UMLStringRecognizer.NAME)  // potential class name
			umlText.setAttribute("FontStyle",new Integer(Font.BOLD));
		else
			umlText.setAttribute("FontStyle",new Integer(Font.PLAIN));	
	}
	
	public Figure remove(Figure figure) {
		super.remove(figure);
		Object style = figureProperties.remove(figure);
		if (style!=null) 
			figure.setAttribute("FontStyle",style);
		if (figure instanceof UMLTextFigure)
				((UMLTextFigure)figure).removeContentsListener(this);
		
		return figure;
	}
	
  protected DrawLayoutManager getDefaultLayoutManager() {
   	CenteredVListLayout l = new CenteredVListLayout(1);
   	l.setEmptySize(new Dimension(60,20));
   	return l;
  } 
}