package CH.ifa.draw.samples.statechart;

import relap.Analyzer.MiddleNode;
import relap.Analyzer.EmptyNode;
import relap.Analyzer.LeafNode;
import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.Copying;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.framework.*;


public class CompositeStateCompartmentRep 
	extends MiddleNode 
	implements StateChartNode,StateContainer {

	public void accept(StateChartVisitor visitor) {
		visitor.visitCompositeStateCompartmentRep(this);
	}
	
	public LeafNode getPanel() {
		return (LeafNode)getDescendantAt(0);
	}
	
	public SList getInternals() {
		return (SList)getOptionalDescendantAt(1);
	}		
	
	public InitialRep getInitial() {
		return (InitialRep)getOptionalDescendantAt(2);
	}
	
	public SList getStates() {
		return (SList)getDescendantAt(3);
	}		
	
	public SList getFinals() {
		return (SList)getOptionalDescendantAt(4);
	}		
	
	public SList getContainedStates() {
		SList list = new SList();
		if (getInitial() != null)
			list.pushBack(getInitial());
		if (getStates()!=null)
			Copying.copy(getStates(),list);
		if (getFinals()!=null)
			Copying.copy(getFinals(),list);
		return list;
	}	
}