package CH.ifa.draw.samples.statechart;

import com.objectspace.jgl.Array;
import com.objectspace.jgl.SList;

//import relap.Editor.Figures.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import relap.Editor.ContainmentToRelationMapper;
import relap.Editor.VisitorException;
import relap.Editor.InputGenerationState;
import relap.LanguageModel.InvalidTupleException;
import relap.Editor.NoSuchRelationException;

import CH.ifa.draw.contrib.xcomp.*;

public class LabelToRelation 
	extends ContainmentToRelationMapper {
	
	String fLabelRelation;
	
	public LabelToRelation(String relationName,String labelRelation,String excludeClass) {
		this(relationName,labelRelation,new SList(1,excludeClass));
	}
	
	public LabelToRelation(String relationName,String labelRelation) {
		this(relationName,labelRelation,new SList());
	}

	public LabelToRelation(String relationName,String labelRelation,SList excludes) {
		super(relationName,excludes);
		fLabelRelation = labelRelation;
	}
	
	public String getLabellingRelationName() {
		return fLabelRelation;
	}

	public void visit(Object target,Object visitorState)
		throws VisitorException {
		if (!(target instanceof LabelPanel))
			throw new VisitorException("LabelPanel object expected");
		LabelPanel label = (LabelPanel)target;
		if (label.hasLabels()) { // ignore empty label containers!
			super.visit(target,visitorState);
			InputGenerationState state = (InputGenerationState)visitorState;
			if (label.isConnected()) {
				Array tuple = new Array(2);
				tuple.put(0,label);
				tuple.put(1,label.getObservedFigure());
				try {
					state.addImplicitRelationTuple(getLabellingRelationName(),tuple);
					state.dispatchVisit(label.getObservedFigure());
				} 
				catch (InvalidTupleException e) {
					throw new VisitorException(e.getMessage());
				}
				catch (NoSuchRelationException e) {
					throw new VisitorException(e.getMessage());
				}
			}
		}
	}
	
}