
package CH.ifa.draw.samples.statechart;


import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.application.*;
import CH.ifa.draw.contrib.*;
import CH.ifa.draw.samples.javadraw.*;
import CH.ifa.draw.contrib.xcomp.*;
import CH.ifa.draw.samples.statechart.semantics.StateChartAnalyzer;
import relap.Editor.*;


public  class StateChartEditor extends RelapApp {

    private static String       fgSampleImagesPath = "CH/ifa/draw/samples/javadraw/sampleimages/";
    private static String       fgSampleImagesResourcePath = "/"+fgSampleImagesPath;

    StateChartEditor() {
        super("VILPERT - Statecharter");
    }

    //-- DrawApplication overrides -----------------------------------------
    
    protected void createTools(Panel palette) {
        super.createTools(palette);

        Tool tool = new CreationTool(view(), new SuperState());
        palette.add(createToolButton(IMAGES+"RRECT", "State Tool", tool));

        tool = new TransitionTool(view(), new Transition());
        palette.add(createToolButton(IMAGES+"UNICONN", "Transition Tool", tool));

        tool = new TextTool(view(), new TextFigure());
        palette.add(createToolButton(IMAGES+"TEXT", "Text Tool", tool));

        tool = new CreationTool(view(),new NameCompartment());
        palette.add(createToolButton(IMAGES+"NAMECOMP", "Name Compartment Tool", tool));

        tool = new CreationTool(view(),new ITCompartment());
        palette.add(createToolButton(IMAGES+"ITCOMP", "Internal Transiton Compartment Tool", tool));

        tool = new CreationTool(view(),new StateCompartment());
        palette.add(createToolButton(IMAGES+"STATECOMP", "State Compartment Tool", tool));

        tool = new CreationTool(view(), new StartDot());
        palette.add(createToolButton(IMAGES+"DOT", "Start Tool", tool));

        tool = new CreationTool(view(), new EndDot());
        palette.add(createToolButton(IMAGES+"BULLSEYE", "End Tool", tool));
   }

    protected Tool createSelectionTool() {
        return new SpecialSelectionTool(view());
    }

		
  protected Menu createAnalyzeMenu() {
		Menu menu = super.createAnalyzeMenu();
		menu.addSeparator();
		CheckboxMenuItem mi = new CheckboxMenuItem("Docked windows");
		mi.addItemListener(
		    new ItemListener() {
		    	public void itemStateChanged(ItemEvent e) {
		        if (((CheckboxMenuItem)e.getSource()).getState())
		          ((RelapAnalysisView)getAnalyzerView()).attachTo(StateChartEditor.this);
		        else 
		        	((RelapAnalysisView)getAnalyzerView()).detach();
		      }
		    }
		);
		menu.add(mi);
		/*mi = new MenuItem("Detach Analyzer");
		mi.addActionListener(
		    new ActionListener() {
		        public void actionPerformed(ActionEvent event) {
		            ((RelapAnalyzer)getAnalyzer().detach();
		        }
		    }
		);
		menu.add(mi); */
		return menu;
	}

	protected StandardDrawingView createDrawingView() {
		StandardDrawingView v = super.createDrawingView();
		//v.setBackground(Color.white);
		return v;
	}

    protected Drawing createDrawing() {
        //return new BouncingDrawing();
        return new StandardDrawing();
    }

    protected Window createAnalyzerView() {
        return new StateChartAnalysisView(this,new StateChartAnalyzer(this),"Statechart Analyzer");
    }

    //-- main -----------------------------------------------------------

	public static void main(String[] args) {
		StateChartEditor window = new StateChartEditor();
		window.open();
    }
}