package CH.ifa.draw.samples.statechart;

import relap.Analyzer.SyntaxTreeNode;
import relap.Analyzer.SyntaxTreeIterator;
import relap.Editor.SemanticProcessor;

public class StateChartPrinter implements SemanticProcessor {

	public Object process(SyntaxTreeNode tree) {
		StringBuffer buf = new StringBuffer(tree.getDescription());
		SyntaxTreeIterator node = tree.start();
		while (!node.atEnd()) {
			if (!((node instanceof TransitionRep) ||
				     (node instanceof LabelRep) ||
				     (node instanceof NameCompartmentRep) &&
				     (node instanceof InitialRep) ||
				     (node instanceof FinalRep)))	{
				for (int i = 0;i < node.depth();i++)
					buf.append("   ");
				buf.append(node.current().getDescription()+"\n");
			}
			node.advance();
		}
		return buf.toString();
	}

}