
package CH.ifa.draw.samples.statechart;



import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.contrib.xcomp.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


//public class State extends StructuredCompositeFigure {
public class SuperState extends FrameComposite {


  public SuperState() {
    super();
  }
  public SuperState(Point origin, Point corner) {
    super(origin,corner);
  }

  /**
   * Creates a RootRoundRectangleFigure.
   */
  protected RootFigure createRootFigure(){
    return new RootRoundRectangleFigure(this);
  }

  /**
   * Creates a RootRoundRectangleFigure.
   */
  protected RootFigure createRootFigure(Point origin, Point corner) {
    return new RootRoundRectangleFigure(origin,corner,this);
  }
  
  /**
   * Creates the default state compartment for this super state.
   */
  public void created() {
 		if (figureCount() == 0)
 			super.add(
				new StateCompartment(displayBox().getLocation(),new Point(0,0))
			);
 }


  protected DrawLayoutManager getDefaultLayoutManager() {
   	//return new BagFlowLayout();
   	//return new VListLayout();
   	//return new VListCenteringLayout();
   	return new SuperStateLayout(2);
  } 

	public Insets getInsets() {
		return new Insets(5,3,5,3);
	}
	
	public boolean accept(Figure figure) {
		if (figureCount() == 0)
			return true;
		if (   (figure instanceof StateCompartment)
			   ||(figure instanceof NameCompartment)
			   ||(figure instanceof ITCompartment)
			 ) 
			return true;
		return false;
	}
	


  /**
   * Draws a horizontal solid line after each name compartment and a
   * vertical dashed line after each state machine compartment (except the
   * last).
   */
	public void drawDividers(Graphics g) {
		//System.err.println("drawdividers");
		Vector compartments = ((SuperStateLayout)getLayout()).getComponents();
 		for (int i = 0;i < compartments.size()-1;i++) {
 			Rectangle r =((Figure)compartments.elementAt(i)).displayBox();
 			//System.err.println("drawDividers: "+i+" "+r);
      if ((compartments.elementAt(i) instanceof NameCompartment) ||
      	  (compartments.elementAt(i) instanceof ITCompartment))
        g.drawLine(r.x,r.y+r.height,r.x+r.width-1,r.y+r.height);
      else
        RenderingTool
          .drawDashedLine(g,r.x,r.y+r.height,r.x+r.width,r.y+r.height-1,4);
 		}
  }

	public Figure add(Figure figure) {
		if (figureCount() == 0 && !(figure instanceof Compartment)) {
			StateCompartment c =
					(StateCompartment)super.add(
						new StateCompartment(displayBox().getLocation(),new Point(0,0))
					);
			if (!((figure instanceof NameCompartment) || (figure instanceof ITCompartment)))
				return c.add(figure);
		}
		return super.add(figure);
	}
	
	public Figure remove(Figure figure) {
		super.remove(figure);	
		
		// if the remaining compartments are all name compartments,
		// creates a new state compartment.
	/*	Vector compartments = ((SuperStateLayout)getLayout()).getComponents();
		boolean allNames = true;
		int i = 0;
		while (allNames && i < compartments.size()) {
			if (compartments.elementAt(i) instanceof StateCompartment)
				allNames = false;
			i++;
		}
		if (allNames) 
			super.add(
				new StateCompartment(displayBox().getLocation(),new Point(0,0))
			); */
		return figure;
	}
    /**
     * Draws all the contained figures. Calls drawDividers() (this is a template
     * method).
     * @see Figure#draw
     */
  public void draw(Graphics g) {
    Shape clip = g.getClip();
	  Rectangle r = displayBox();
    g.clipRect(r.x,r.y,r.width,r.height);
    super.draw(g);
    drawDividers(g);
    g.setClip(clip);
  }
 
}