package CH.ifa.draw.samples.statechart;

import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.contrib.xcomp.*;
import java.awt.*;
import java.util.*;
import java.io.*;
import com.objectspace.jgl.algorithms.Sorting;
import com.objectspace.jgl.algorithms.Copying;

import com.objectspace.jgl.*;
import com.objectspace.jgl.adapters.VectorArray;
import com.objectspace.jgl.predicates.BinaryNot;

/**
 * The basic implementation for list-like layout strategies.
 * Like BagLayout this layout manager positions the contained
 * figures 'as they were'. That is, no positioning is performed.
 * This is an example implementation that shows how the mechanisms
 * of super classes are used to create specialized layout managers.
 */ 

// make superstatelayout maintain a logical order of compartments:
// name compartments on the top!

public class SuperStateLayout extends VTiledLayout {

	public SuperStateLayout() {
		super();
	}
	
	public SuperStateLayout(int hgap) {
		super(hgap);
	}
	
	

	protected Vector getNameCompartments() {
		Vector names = new Vector();
		for (int i=0;i<fComponents.size();i++)
			if (fComponents.elementAt(i) instanceof NameCompartment)
				names.addElement(fComponents.elementAt(i));
		return names;
	}
	
	protected Vector getITCompartments() {
		Vector names = new Vector();
		for (int i=0;i<fComponents.size();i++)
			if (fComponents.elementAt(i) instanceof ITCompartment)
				names.addElement(fComponents.elementAt(i));
		return names;
	}

	protected Vector getStateCompartments() {
		Vector states = new Vector();
		for (int i=0;i<fComponents.size();i++)
			if (fComponents.elementAt(i) instanceof StateCompartment)
				states.addElement(fComponents.elementAt(i));
		return states;
	}
	
	protected void attachAligners() {
		Vector names = getNameCompartments();
		Vector internals = getITCompartments();
		Vector states = getStateCompartments();
  	Sorting.sort(
  		new VectorArray(names),
  		new BinaryNot(getOrderingPredicate())
  	);
   	Sorting.sort(
  		new VectorArray(internals),
  		new BinaryNot(getOrderingPredicate())
  	);
 		Sorting.sort(
  		new VectorArray(states),
  		new BinaryNot(getOrderingPredicate())
  	);
  	fComponents.removeAllElements();
		Copying.copy(new VectorArray(names),new VectorArray(fComponents));
		Copying.copy(new VectorArray(internals),new VectorArray(fComponents));
		Copying.copy(new VectorArray(states),new VectorArray(fComponents));
		//super.attachAligners();
  }

	
}