

package CH.ifa.draw.samples.statechart;

import CH.ifa.draw.standard.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.KeyEvent;
import java.util.*;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.Geom;

public class TransitionTool extends ConnectionTool {
  /**
   * Flag to indicate that the mouse is being dragged.
   */
  protected boolean fDragged = false;
  protected Point fAnchor = null;
  public TransitionTool(DrawingView view, ConnectionFigure prototype) {
    super(view,prototype);
  }

    /**
     * Turn fDragged-flag off.
     */
  public void mouseDown(MouseEvent e, int x, int y) {
    fDragged = false;
    super.mouseDown(e,x,y);
    fAnchor = new Point(x,y);
  }

    /**
     * Turn fDragged-flag off.
     */
    public void mouseUp(MouseEvent e, int x, int y) {
      fDragged = false;
      super.mouseUp(e,x,y);
      fAnchor = null;
    }

    /**
     * Adjust the created connection or split segment. Turn fDragged-flag
     * on if not yet set.
     */
    public void mouseDrag(MouseEvent e, int x, int y) {
        fDragged = true;
        super.mouseDrag(e,x,y);
        fAnchor = new Point(x,y);
    }

    public void keyDown(KeyEvent evt, int key) {
      if (evt.getID() == KeyEvent.KEY_PRESSED) {
        //System.err.println("key "+evt.getKeyText(evt.getKeyCode())+" pressed");
        if (evt.getKeyCode()==KeyEvent.VK_CONTROL && fConnection != null) {
          //System.err.println("pointCount(): "+((LineConnection)fConnection).pointCount());
          ((LineConnection)fConnection).
            insertPointAt(
              new Point(fAnchor),
              ((LineConnection)fConnection).pointCount()-1
            );
        }
      }
    }

}