package CH.ifa.draw.samples.statechart.semantics;

import java.util.*;
import com.objectspace.jgl.*;

public abstract class AbstractContext implements Context {
	
	protected HashMap fEvents;
	protected Vector fActions;
		
	public AbstractContext() {
		fEvents = createEvents();
		fActions = createActions();
	}
		
	abstract protected HashMap createEvents();
	
	abstract protected Vector createActions();
	
	public Vector getEventNames() {
		Vector names = new Vector();
		Enumeration k = fEvents.keys();
		while (k.hasMoreElements()) 
			names.addElement(k.nextElement());
		return names;
	}
	
	public Vector getEvents() {
		Vector events = new Vector();
		Enumeration e = fEvents.elements();
		while (e.hasMoreElements())
			events.addElement(e.nextElement());
		return events;
	}
	
	public Event getEvent(String name) {
		return (Event)fEvents.get(name);
	}
	
	public Vector getActionNames() {
		return (Vector)fActions.clone();
	}
	
	public void perform(String action) throws ActionException {
		if (!fActions.contains(action))
			throw new ActionException("Context - unknown action: "+action);
		System.out.println("performing "+action);
	}
	
}