package CH.ifa.draw.samples.statechart.semantics;

import java.util.*;

abstract public class AbstractTransition extends StateChartObject {
	
	protected String fTrigger;
	protected String fEffect;
	
	public AbstractTransition() {
		fTrigger = new String("");
		fEffect = new String("");
	}
	
	public String getTrigger() {
		return fTrigger;
	}
		
	public void setTrigger(String trigger) {
		fTrigger = trigger.trim();
	}

	public String getEffect() {
		return fEffect;
	}
		
	public void setEffect(String effect) {
		fEffect = effect.trim();
	}
	
	abstract public State getOwner();

	public void check(Vector errors) {
		Context context = getOwner().getStateMachine().getContext();
		if (!getTrigger().equals("") && 
			  !context.getEventNames().contains(getTrigger()))
			 addError(errors,"Unknown event: '"+getTrigger()+"'",getOwner());	
		if (!getEffect().equals("") && 
			  !context.getActionNames().contains(getEffect()))
			 addError(errors,"On "+getTrigger()+" - unknown action: '"+getEffect()+"'",getOwner());	
	}
}