package CH.ifa.draw.samples.statechart.semantics;

import java.util.Vector;

public class Event {
	
	protected String fName;
	protected Vector fParameters;
	
	public Event(String name) {
		this(name, new Vector());
	}

	public Event(String name,Vector params) {
		fName = name;
		fParameters = (Vector)params.clone();
	}
	
	public String getName() {
		return fName;
	}
	
	public Vector getParameters() {
		return (Vector)fParameters.clone();
	}
	
	public void setParameters(Vector params) {
		fParameters = (Vector)params.clone();
	}
	
	public void addParameter(String typeSignature) {
		if (fParameters==null)
			fParameters = new Vector();
		fParameters.addElement(typeSignature);
	}
	
	public boolean equals(Object other) {
		if (super.equals(other))
			return true;
		if (!(other instanceof Event))
			return false;
		if (!fName.equals(((Event)other).getName()))
			return false;
		if (!fParameters.equals(((Event)other).getParameters()))
			return false;
		return true;
	}
}