package CH.ifa.draw.samples.statechart.semantics;

import relap.Analyzer.*;
import java.util.Vector;
import java.io.*;

public class Fail implements ProcessingResult {
	
	StateMachine fMachine;
	Vector fErrors;
	Vector fWarnings;
	
	public Fail(StateMachine machine,Vector errors) {
		fMachine = machine;
		fErrors = (Vector)errors.clone();
		fWarnings = new Vector();
	}
	
	public Fail(StateMachine machine,Vector errors,Vector warnings) {
		fMachine = machine;
		fErrors = (Vector)errors.clone();
		fWarnings = (Vector)warnings.clone();
	}
	
	public StateMachine getMachine() {
		return fMachine;
	}
	
	public boolean success() {
		return false;
	}
	
	public Object product() {
		return getMachine();
	}
	
	public Vector errors() {
		return (Vector)fErrors.clone();
	}
	
	public Vector warnings() {
		return (Vector)fWarnings.clone();
	}
	
	public void reportOn(PrintWriter log) {
		log.println("failed: ");
		for (int i = 0;i < fErrors.size();i++)
			log.println(fErrors.elementAt(i));
	}
	
	public String toString() {
		StringWriter buf = new StringWriter();
		reportOn(new PrintWriter(buf));
		return buf.toString();			
	}
}