package CH.ifa.draw.samples.statechart.semantics;

import com.objectspace.jgl.*;
import java.util.Enumeration;

public class Flaw {
	
	protected String fDescription;
	protected HashSet fObjects;
	protected Severity fSeverity;
	
	public Flaw(String msg,HashSet objects) {
		this (msg,objects,Severity.createError());
	}
	
	public Flaw(String msg,Object object) {
		this (msg,object,Severity.createError());
	}	
		
	public Flaw(String msg,Object object,Severity severity) {
		fDescription = msg;
		HashSet objects = new HashSet();
		objects.add(object);
		fObjects = objects;
		fSeverity = severity;
	}

	public Flaw(String msg,HashSet objects,Severity severity) {
		fDescription = msg;
		fObjects = new HashSet(objects);
		fSeverity = severity;
	}
	
	public Severity getSeverity() {
		return fSeverity;
	}
		
	public String getDescription() {
		return fDescription;
	}
	
	public HashSet getObjects() {
		return new HashSet(fObjects);
	}
	
	public Enumeration getEnumeration() {
		return fObjects.elements();
	}
	
	public boolean equals(Object other) {
		if (this==other)
			return true;
		if ((other instanceof Flaw) 
			  && ((Flaw)other).getDescription().equals(fDescription)
			  && ((Flaw)other).getObjects().equals(fObjects))
			return true;
		return false;
	}

}