package CH.ifa.draw.samples.statechart.semantics;

import relap.Analyzer.*;
import java.util.Vector;
import java.io.*;

public class Pass implements ProcessingResult {
	
	StateMachine fMachine;
	Vector fWarnings;
	
	public Pass(StateMachine machine) {
		fMachine = machine;
		fWarnings = new Vector();
	}
	
	public Pass(StateMachine machine,Vector warnings) {
		fMachine = machine;
		fWarnings = (Vector)warnings.clone();
	}

	public StateMachine getMachine() {
		return fMachine;
	}
	
	public boolean success() {
		return true;
	}
	
	public Object product() {
		return getMachine();
	}
	
	public Vector errors() {
		return new Vector();
	}
	
	public Vector warnings() {
		return (Vector)fWarnings.clone();
	}
	
	public void reportOn(PrintWriter log) {
		log.println(getMachine());
	}
}