package CH.ifa.draw.samples.statechart.semantics;

import com.objectspace.jgl.*;
import java.util.Vector;


public abstract class PseudoState 
	extends State {

  public String getName() {
  	return "<anonymous>";
  }

  public void setName() {
  	// has no name - use id
  }

	protected HashSet checkName() {
		return new HashSet();
	}

	public void check(Vector accuErrors) {
		super.check(accuErrors);
		HashSet err = new HashSet();
		for (ForwardIterator tr = getOutgoing();!tr.atEnd();tr.advance()) {
			AbstractTransition trans = (AbstractTransition)tr.get();
			if (!trans.getTrigger().equals(""))
				err.add(trans);
		}
		if (!err.isEmpty()) 
			addError(accuErrors,"Transitions leaving pseudostates cannot have triggers",err);		
	}
}