package CH.ifa.draw.samples.statechart.semantics;

import relap.Editor.ProcessingError;
import relap.Editor.ErrorInterpreter;
import com.objectspace.jgl.*;
import relap.Analyzer.ParseState;
import java.util.Enumeration;

public class StateChartError implements ProcessingError {
	
	protected String eMsg;
	protected HashSet eObjects;
	
	public StateChartError(String msg,Enumeration objects) {
		eMsg = msg;
		eObjects = new HashSet();
		while (objects.hasMoreElements())
			eObjects.add(objects.nextElement());
	}
	
	public StateChartError(String msg,HashSet objects) {
		eMsg = msg;
		eObjects = new HashSet(objects);
	}
	
	public StateChartError(Flaw flaw,SemanticMap map) {
		eMsg = flaw.getDescription();
		eObjects = new HashSet();
		Enumeration o = flaw.getEnumeration();
		while (o.hasMoreElements()) {
			Enumeration g = map.getGraphic(o.nextElement());
			while (g.hasMoreElements())
				eObjects.add(g.nextElement());
		}
	}
	
 	public Sequence unPack() {
 		SList l = new SList();
 		l.pushBack(this);
 		return l;
 	}
 
 	public ParseState location() {
 		return null;
 	}
 
	public HashSet indices() {
		return eObjects;
	}
	
	public String describeWith(ErrorInterpreter interpreter) {
		return eMsg;
	}	
}