package CH.ifa.draw.samples.statechart.semantics;

import relap.Analyzer.MiddleNode;
import relap.Analyzer.LeafNode;
import relap.Util.*;
import com.objectspace.jgl.Pair;
import java.util.Vector;

public class Transition 
	extends AbstractTransition
	implements DirectedEdge {
	
	protected DiGraphEdge fDiGE;
	
	public Transition() {
		super();
		fDiGE = new DiGraphEdge();
	}
	
	public StateVertex getSource() {
		return (StateVertex)getStart();
	}
	
	public void setSource(StateVertex source) {
		setStart(source);
	}

	public StateVertex getTarget() {
		return (StateVertex)getEnd();
	}
		
	public void setTarget(StateVertex target) {
		setEnd(target);
	}
	
	public void setVertices(Pair vertices) {
		fDiGE.setVertices(vertices);
	}
	
	public void setVertices(Object o1,Object o2) {
		fDiGE.setVertices(o1, o2);
	}
	
	public Pair getVertices() {
		return fDiGE.getVertices();
	}

	public Object getStart() {
		return fDiGE.getStart();
	}

	public Object getEnd() {
		return fDiGE.getEnd();
	}
	
	public void setStart(Object o) {
		fDiGE.setStart(o);
	}

	public void setEnd(Object o) {
		fDiGE.setEnd(o);
	} 
	
	public void check(Vector accuErrors) {
		if (!((getStart() instanceof StateVertex) && (getEnd() instanceof StateVertex)))
			addError(accuErrors,"Transitions must start from and end to a state vertex",this);
		else {
			super.check(accuErrors);
			//Context context = getOwner().getStateMachine().getContext();
			//if (!getEffect().equals("") && 
			//	  !context.getActionNames().contains(getEffect()))
			// 	addError(accuErrors,"On "+getTrigger()+" - unknown action: '"+getEffect()+"'",this);	
		}
	}
	
	public State getOwner() {
		return (State)getSource();
	}
	
	public String toString() {
		StringBuffer buf = new StringBuffer("transition on ");
		if (getTrigger().equals(""))
			buf.append("'completion event'");
		else
			buf.append("'"+getTrigger()+"'");
		if (!getEffect().equals(""))
			buf.append(" action '"+getEffect()+"'");
		if (getTarget()==null)
			buf.append(" to unspecified state");
		else
			buf.append(
				" to state "+getTarget().getName()+" (id: "+getTarget().getId()+")"
			);
		return buf.toString();
	}
}