package CH.ifa.draw.samples.tree;

import relap.LanguageModel.*;
import com.objectspace.jgl.*;

public class Tree extends RelationalGrammarImplementation {
	
	HashSet fFixedStartAttrs;

	public String terminalDeclarations () {
		return "circle text ";
	}

	public String nonTerminalDeclarations () {

		return "Tree Node";

	}
	public String startSymbolDeclaration () {

		return "Tree";

	}

	public String relationDeclarations () {

		return "inside linked ";

	}

	public String attributeDeclarations () {

		return "root ";

	}

	public HashSet fixedStartAttributes() {
		if (fFixedStartAttrs == null) {
			fFixedStartAttrs = new HashSet();
			fFixedStartAttrs.add("root");
		}
		return fFixedStartAttrs;
	} 

	public GrammarProduction Tree_full(GrammarProduction p) 
	throws InvalidGrammarException {

		p.description("Tree with two children");
		p.rightHandSide("Node Tree Tree");
		p.constraints("linked(1:root,2:root) linked(1:root,3:root)");
		p.predicates("left(2:root,3:root)");
		p.order("2,3 left");
		p.assignments("0:root = 1:root");
		//p.semantics("CH.ifa.draw.samples.statechart.StateChartRep");
		return p;	 
	}

	public GrammarProduction Tree_leaf(GrammarProduction p) 
	throws InvalidGrammarException {

		p.description("Tree with no children");
		p.rightHandSide("Node");
		p.disambiguate("~linked(1:root,_)");
		//p.predicates("left(2:root,3:root)");
		p.assignments("0:root = 1:root");
		//p.semantics("CH.ifa.draw.samples.statechart.StateChartRep");
		return p;	 
	}
	
	public GrammarProduction Node_(GrammarProduction p) 
	throws InvalidGrammarException {

		p.description("Node of a Tree");
		p.rightHandSide("circle text?");
		p.constraints("inside(2,1)");
		//p.predicates("left(2:root,3:root)");
		p.assignments("0:root = 1");
		//p.semantics("CH.ifa.draw.samples.statechart.StateChartRep");
		return p;	 
	}
	
}