package CH.ifa.draw.samples.tree;

import relap.Editor.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.samples.statechart.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.*;
import com.objectspace.jgl.predicates.*;
import relap.Analyzer.*;
import relap.LanguageModel.*;


public class TreeAnalyzer extends AbstractAnalyzer {
	
	public TreeAnalyzer(DrawingEditor editor) {
		super(editor);
	}
	
	
	protected String getGrammar() {
		return "CH.ifa.draw.samples.tree.Tree2";
	}
	
	protected ObjectToVisitorMap getVisitorMap() {
		return new TreeInputGeneratorMap();
	}
	
	protected ObjectToSymbolMap getSymbolMap() {
		return new TreeEditorMap();
	}
		

	protected void initRelations(IndexedMDSet input) {
		input.addRelation(
			new ExplicitExpanderRelation(
				"linked","link","starting from","ending to"
		    )
		);
		input.addRelation(
			new ImplicitExpanderRelation("inside","inside of","containing")
		);	
	}	
	
	protected Object getStartObject(IndexedMDSet input,ObjectToSymbolMap map) {
		Enumeration starters = 
			((ExpanderRelation)input.getRelation("linked")).minimalObjects();
		Object starter = null;
		
		if (!starters.hasMoreElements()) 
			starters = 
			Filtering.select(
				input.objects(),
				new BindSecondPredicate(
					new BinaryPredicate() {
						public boolean execute(Object editorObject,Object map) {
							return
								((ObjectToSymbolMap)map).
									mapObjectToSymbol(editorObject).
										equals("circle");
						}
					},
					map
				)
			).elements();
			
		if (starters.hasMoreElements())
			starter = starters.nextElement();

		// if starter == null then pick any non-connection symbol?
		//  -- got to process _something_ 
		
		System.err.println(starter);
		while (starters.hasMoreElements())
			System.err.println(starters.nextElement());
			
		return starter;
	}

	public boolean left(Object f1,Object f2) {
		return ((Figure)f1).center().x < ((Figure)f2).center().x;
	} 

	public boolean right(Object f1,Object f2) {
		return ((Figure)f1).center().x >= ((Figure)f2).center().x;
	} 

	public boolean above(Object f1,Object f2) {
		return ((Figure)f1).center().y < ((Figure)f2).center().y;
	} 
	
	/*
	public BinaryPredicate above() {
		return new BinaryPredicate() {
			public boolean execute(Object f1,Object f2) {
				return 
					((Figure)f1).displayBox().getLocation().y < ((Figure)f2).displayBox().getLocation().y;
			} 
		};
	}
	*/
	public BinaryPredicate left() {
		return new BinaryPredicate() {
			public boolean execute(Object f1,Object f2) {
				return ((Figure)f1).displayBox().getLocation().x < ((Figure)f2).displayBox().getLocation().x;
			} 
		};
	}
	
}