
package CH.ifa.draw.samples.tree;


import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.application.*;
import CH.ifa.draw.contrib.*;
import CH.ifa.draw.samples.javadraw.*;
import CH.ifa.draw.contrib.xcomp.*;
//import CH.ifa.draw.samples.statechart.semantics.StateChartAnalyzer;
import relap.Editor.*;


public  class TreeEditor extends RelapApp {

    private static String       fgSampleImagesPath = "CH/ifa/draw/samples/javadraw/sampleimages/";
    private static String       fgSampleImagesResourcePath = "/"+fgSampleImagesPath;

    TreeEditor() {
        super("VILPERT - Tree Editor");
    }

    //-- DrawApplication overrides -----------------------------------------
    
    protected void createTools(Panel palette) {
        super.createTools(palette);

        Tool tool = new CreationTool(view(), new Node());
        palette.add(createToolButton(IMAGES+"ELLIPSE", "Node Tool", tool));

        tool = new ConnectionTool(view(), new TreeLink());
        palette.add(createToolButton(IMAGES+"UNICONN", "Link Tool", tool));

        tool = new TextTool(view(), new TextFigure());
        palette.add(createToolButton(IMAGES+"TEXT", "Text Tool", tool));

   }

    protected Tool createSelectionTool() {
        return new SpecialSelectionTool(view());
    }

		
  protected Menu createAnalyzeMenu() {
		Menu menu = super.createAnalyzeMenu();
		menu.addSeparator();
		CheckboxMenuItem mi = new CheckboxMenuItem("Tiled windows");
		mi.addItemListener(
		    new ItemListener() {
		    	public void itemStateChanged(ItemEvent e) {
		        if (((CheckboxMenuItem)e.getSource()).getState())
		          ((RelapAnalysisView)getAnalyzerView()).attachTo(TreeEditor.this);
		        else 
		        	((RelapAnalysisView)getAnalyzerView()).detach();
		      }
		    }
		);
		menu.add(mi);
		/*mi = new MenuItem("Detach Analyzer");
		mi.addActionListener(
		    new ActionListener() {
		        public void actionPerformed(ActionEvent event) {
		            ((RelapAnalyzer)getAnalyzer().detach();
		        }
		    }
		);
		menu.add(mi); */
		return menu;
	}


    protected Drawing createDrawing() {
        //return new BouncingDrawing();
        return new StandardDrawing();
    }

    protected Window createAnalyzerView() {
        return new TreeAnalysisView(this,new TreeAnalyzer(this),"Tree Analyzer");
    }

    //-- main -----------------------------------------------------------

	public static void main(String[] args) {
		TreeEditor window = new TreeEditor();
		window.open();
    }
}