package CH.ifa.draw.standard;

import CH.ifa.draw.framework.*;
import java.awt.*;
import java.util.Vector;

/**
 * BoxHandle implements the common funtionality of box handles.
 * It sets the current manipulator of the owner figure to this
 * in invokeStart() and sets it again to null in invokeEnd().
 */
public class BoxHandle extends LocatorHandle {

    public BoxHandle(Figure owner, Locator l) {
        super(owner,l);
    }
    
    /**
     * Sets this handle as the manipulator of the owning figure.
     */
    public void invokeStart(int  x, int  y, DrawingView view) {
        super.invokeStart(x, y, view);
        owner().setManipulator(this);
    }

     
    /**
     * Unsets this handle as the manipulator of the owning figure.
     */
   public void invokeEnd(int x, int y, int anchorX, int anchorY, DrawingView view) {
        super.invokeEnd(x,anchorX, y,anchorY, view);
        owner().setManipulator(null);
    }
}