/*
 * @(#)DragTracker.java 5.1
 *
 */

package CH.ifa.draw.standard;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.util.*;
import CH.ifa.draw.framework.*;

/**
 * DragTracker implements the dragging of the clicked
 * figure.
 *
 * @see SelectionTool
 */
public class DragTracker extends AbstractTool
                         implements Runnable {

    private Figure  fAnchorFigure;
    private int     fLastX, fLastY;      // previous mouse position
    private boolean fMoved = false;
    private boolean fDragging = false;
    private boolean fPosChanged = false;
	  private Thread fFinder = null;
    private boolean fAbortFind = true;
    private Vector fDropTargets;

    public DragTracker(DrawingView view, Figure anchor) {
        super(view);
        fAnchorFigure = anchor;
    }

	private boolean differentParents(Vector figures,Figure selected) {
		Enumeration f = figures.elements();
		while (f.hasMoreElements()) 
			if (((Figure)f.nextElement()).parent() != selected.parent())
				return true;

		return false;
	}

	private void resetDropTargets() {
    if (!fDropTargets.isEmpty()) {
      Enumeration figure = fDropTargets.elements();
      while (figure.hasMoreElements())
        ((Figure)figure.nextElement()).setHighlighted(false);
      fDropTargets.removeAllElements();
    }
  }

 private void showDropTargets() {
  FigureEnumeration figures = view().selectionElements();
  while (figures.hasMoreElements()) {
    Figure figure = figures.nextFigure();
    //System.out.println("finding...");
    Figure dropTarget =
      ((Figure)drawing()).findDropTarget(
        figure.center().x,
        figure.center().y,
        figure
      );
    dropTarget.setHighlighted(true);
    fDropTargets.addElement(dropTarget);
    //if (dropTarget != null)
    //  System.err.println("--> dropTarget "+dropTarget);
  }
 }

   public void mouseDown(MouseEvent e, int x, int y) {
    //System.err.println("MOUSE DOWN");
    fDragging = true;
    fDropTargets = new Vector();
    super.mouseDown(e, x, y);
    fLastX = x;
    fLastY = y;
    Enumeration figure = view().selection().elements();
    while (figure.hasMoreElements())
      ((Figure)figure.nextElement()).endDrag(e);
		//DragTransactionManager manager = DragTransactionManager.getInstance();
		//manager.clearDragTargets();
    //if (!(e.isShiftDown() && view().selection().contains(fAnchorFigure)))
		//	manager.addAboutToMove(fAnchorFigure);
		if (differentParents(view().selection(),fAnchorFigure)) {
			//view().removeFromSelection(fAnchorFigure);
			//fAnchorFigure = null;
            //Enumeration figure = view().selection().elements();
            //while (figure.hasMoreElements())
            //  ((Figure)figure.nextElement()).endDrag();
           	view().clearSelection();
            view().addToSelection(fAnchorFigure);
            //fAnchorFigure.beginDrag();
		} else {

        	if (e.isShiftDown()) {
         	  	view().toggleSelection(fAnchorFigure);
              //if (view().selection().contains(fAnchorFigure))
              //  fAnchorFigure.beginDrag();
              //else
              //  fAnchorFigure.endDrag();
         	  	fAnchorFigure = null;
        	} else if (!view().selection().contains(fAnchorFigure)) {
           	 	view().clearSelection();
            	view().addToSelection(fAnchorFigure);
              //fAnchorFigure.beginDrag();
        	}
    }
    figure = view().selection().elements();
    while (figure.hasMoreElements()) { 
      Figure fig = ((Figure)figure.nextElement());
      fig.beginDrag(e);
      fig.parent().bringToFront(fig);
    }
    //manager.setDragTargets(view().selection());
  }

 /* public void mouseDown(MouseEvent e, int x, int y) {
    //System.err.println("MOUSE DOWN");
    fDragging = true;
    fDropTargets = new Vector();
    super.mouseDown(e, x, y);
    fLastX = x;
    fLastY = y;
    //Enumeration figure;// = view().selection().elements();
    //while (figure.hasMoreElements())
    //  ((Figure)figure.nextElement()).endDrag(e); // ??????
		//DragTransactionManager manager = DragTransactionManager.getInstance();
		//manager.clearDragTargets();
    //if (!(e.isShiftDown() && view().selection().contains(fAnchorFigure)))
		//	manager.addAboutToMove(fAnchorFigure);
		if (differentParents(view().selection(),fAnchorFigure)) {
			//view().removeFromSelection(fAnchorFigure);
			//fAnchorFigure = null;
            Enumeration figure = view().selection().elements();
            while (figure.hasMoreElements())
              ((Figure)figure.nextElement()).endDrag(e);
            fAnchorFigure.beginDrag(e);
           	view().clearSelection();
            view().addToSelection(fAnchorFigure);
            fAnchorFigure.parent().bringToFront(fAnchorFigure);
		} else {

        	if (e.isShiftDown()) {
         	  	
              if (!view().selection().contains(fAnchorFigure)) {
                fAnchorFigure.beginDrag(e);
                fAnchorFigure.parent().bringToFront(fAnchorFigure);
              }
              else
                fAnchorFigure.endDrag(e);
              view().toggleSelection(fAnchorFigure);
         	  	fAnchorFigure = null;
        	} else if (!view().selection().contains(fAnchorFigure)) {
        			fAnchorFigure.beginDrag(e);
           	 	view().clearSelection();
            	view().addToSelection(fAnchorFigure);
            	fAnchorFigure.parent().bringToFront(fAnchorFigure);
              
        	}
    }
    //figure = view().selection().elements();
    //manager.setDragTargets(view().selection());
  }*/

    /* public void mouseDown(MouseEvent e, int x, int y) {
        super.mouseDown(e, x, y);
        fLastX = x;
        fLastY = y;

        if (e.isShiftDown()) {
           view().toggleSelection(fAnchorFigure);
           fAnchorFigure = null;
        } else if (!view().selection().contains(fAnchorFigure)) {
            view().clearSelection();
            view().addToSelection(fAnchorFigure);
        }
    } */

    synchronized public void mouseDrag(MouseEvent e, int x, int y) {
    	//	System.err.println("MOUSE DRAG");
        super.mouseDrag(e, x, y);
        fMoved = (Math.abs(x - fAnchorX) > 4) || (Math.abs(y - fAnchorY) > 4);
        //if (fFinder == null) {
        //  fFinder = new Thread(this,"finder");
        //  fFinder.start();
        //}
       if (fMoved) {
            resetDropTargets();
            FigureEnumeration figures = view().selectionElements();
            while (figures.hasMoreElements()) {
                Figure figure = figures.nextFigure();
                figure.moveBy(x - fLastX, y - fLastY);
                figure.dragged(e);

            }
            showDropTargets();
            fPosChanged = true;
            fAbortFind = true;
        }
        fLastX = x;
        fLastY = y;
    }

    public void mouseUp(MouseEvent e, int x, int y) {
   // System.err.println("MOUSE UP");
    	//System.err.println("view().selection() "+view().selection());
    	//System.err.println("fAnchorFigure "+fAnchorFigure);
      fDragging = false;
      resetDropTargets();
      FigureEnumeration figures = view().selectionElements();
      while (figures.hasMoreElements()) {
        Figure figure = figures.nextFigure();
        boolean wasMoved = figure.hasMoved();
        //System.err.println("***> figure "+figure);
        figure.endDrag(e);
        if (figure instanceof ConnectionFigure) { 
       		continue;
        }
        Figure dropTarget =
          	((Figure)drawing()).findDropTarget(
            	figure.center().x,
            	figure.center().y,
            	figure
          	);
        if (dropTarget != null) { //should always be non-null
           if (dropTarget != figure.parent())
             	dropTarget.drop(figure);
            else if (wasMoved)
              SubfigureMovedEvent.moveSubfigure(figure,figure.parent());
        }
        figure.broughtToFront(); // make sure connections are drawn correctly
        figure.invalidate(); // should be changed()???
 		  }
    //DragTransactionManager.getInstance().clearDragTargets();
	}
  /**
   * This was a good idea - but it won't work because SelectionTool
   * gets the drawing lock on mouseDown and it doesn't release the lock
   * until on mouseUp... (which is probably wise).
   */
	public void run () {
		while (fDragging) {
			try {
				System.out.println("finder sleeping...");
        //fPosChanged = false;
        fAbortFind = false;
				Thread.currentThread().sleep(500);
				synchronized (this) {
					if (fPosChanged && !fAbortFind) {
            FigureEnumeration figures = view().selectionElements();
            while (figures.hasMoreElements()) {
              Figure figure = figures.nextFigure();
					 	  System.out.println("finding...");
              Figure dropTarget =
                ((Figure)drawing()).findDropTarget(
                  figure.center().x,
                  figure.center().y,
                  figure
                );
              dropTarget.setHighlighted(true);
              fDropTargets.addElement(dropTarget);
              //target.changed();
             // System.err.println("--> dropTarget "+dropTarget);
            }
  				 	fPosChanged = false;
					}
					else
						System.out.println("find cancelled");
				} 
			} catch (InterruptedException e) {}
		}
		System.out.println("finder terminating");
	}

}