package CH.ifa.draw.standard;

import CH.ifa.draw.framework.*;
import java.awt.*;

/**
 * A box handle on the upper right corner of the display box.
 */
public class NorthEastHandle extends BoxHandle {
    NorthEastHandle(Figure owner) {
        super(owner, RelativeLocator.northEast());
    }

    public void invokeStep (int x, int y, int anchorX, int anchorY, DrawingView view) {
        Rectangle r = owner().displayBox();
        owner().displayBox(
            new Point(r.x, Math.min(r.y + r.height, y)),
            new Point(Math.max(r.x, x), r.y + r.height)
        );
    }
}