package CH.ifa.draw.standard;

import CH.ifa.draw.framework.*;
import java.awt.*;

/**
 * A box handle on the top edge of the display box.
 */
public class NorthHandle extends BoxHandle {
    NorthHandle(Figure owner) {
        super(owner, RelativeLocator.north());
    }

    public void invokeStep (int x, int y, int anchorX, int anchorY, DrawingView view) {
        Rectangle r = owner().displayBox();
        owner().displayBox(
            new Point(r.x, Math.min(r.y + r.height, y)),
            new Point(r.x + r.width, r.y + r.height)
        );
    }
}