package CH.ifa.draw.standard;

import CH.ifa.draw.framework.*;
import java.awt.*;

/**
 * A box handle on the upper left corner of the display box.
 */
public class NorthWestHandle extends BoxHandle {
    NorthWestHandle(Figure owner) {
        super(owner, RelativeLocator.northWest());
    }

    public void invokeStep (int x, int y, int anchorX, int anchorY, DrawingView view) {
        Rectangle r = owner().displayBox();
        //System.err.println("@@ owner "+owner()+" box "+r);
        owner().displayBox(
            new Point(Math.min(r.x + r.width, x), Math.min(r.y + r.height, y)),
            new Point(r.x + r.width, r.y + r.height)
        );
    }
}