package CH.ifa.draw.samples.classdiagram;

import CH.ifa.draw.standard.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.contrib.xcomp.*;
import java.util.*;
import CH.ifa.draw.samples.classdiagram.work.*;

public class UMLTextFigure extends TextFigure {
	
	protected Vector contentsListeners;
	
	public UMLTextFigure() {
		super();
		contentsListeners = new Vector();
	}
	
	public void addContentsListener(ContentsChangeListener l) {
		if (!contentsListeners.contains(l))
			contentsListeners.addElement(l);
	}
	
	public void removeContentsListener(ContentsChangeListener l) {
			contentsListeners.removeElement(l);
	}
	
	   /**
     * Sets the text shown by the text figure.
     */
 	public void setText(String newText) {
  	String old = getText();
    super.setText(newText);
    if (!newText.equals(old)) // torta p torta, but fText is private in TextFigure!
    	contentsChanged();
 	}

	protected void contentsChanged() {
		for (int i=0;i<contentsListeners.size();i++)
			((ContentsChangeListener)contentsListeners.elementAt(i))
				.contentsChanged(new ContentsChangedEvent(this));
	}
	
}