

package CH.ifa.draw.util;

import java.awt.*;

/**
 * A graphics support class for drawing various shapes.
 */
public class RenderingTool {

	static protected Font fFont = new Font("Helvetica", Font.BOLD, 14);
	static int ifElseWidth = 10;
	
	static public void drawIfElseSymbol(Graphics g,Rectangle box) {
		Color saved = g.getColor();
        g.setFont(fFont);
        FontMetrics metrics = g.getFontMetrics(fFont);
        int halfWidth = metrics.stringWidth("?")/2;
        int halfAscent = metrics.getAscent()/2;
        g.drawString("?", box.x+box.width/2 - halfWidth, box.y + halfAscent + 10);
        int [] leftArrowX = 
        	{ box.x + 4 + 6,box.x + 4 + 6,box.x + 4 }; 
        int [] leftArrowY = 
        	{ box.y + box.height/2 - 4,box.y + box.height/2 + 4,box.y + box.height/2 };
        g.setColor(Color.red);
        g.fillPolygon(leftArrowX,leftArrowY,3); 
		int [] rightArrowX = 
        	{ box.x + box.width - 4 - 6,box.x + box.width - 6 - 4,box.x + box.width - 4 };
        g.setColor(Color.blue);
        g.fillPolygon(rightArrowX,leftArrowY,3); 
        g.setColor(saved);
   	}

	static public void drawIfElseDownSymbol(Graphics g,Rectangle box) {
		Color saved = g.getColor();
        g.setFont(fFont);
        FontMetrics metrics = g.getFontMetrics(fFont);
        int halfWidth = metrics.stringWidth("?")/2;
        int halfAscent = metrics.getAscent()/2;
        g.drawString("?", box.x+box.width/2 - halfWidth, box.y + halfAscent + 10);
        int [] downArrowX = 
        	{ box.x+box.width/2 - 4,box.x+box.width/2 + 4,box.x+box.width/2 }; 
        int [] downArrowY = 
        	{ box.y + box.height - 4 - 6,box.y + box.height - 4 - 6,box.y + box.height - 4};
        g.setColor(Color.red);
        g.fillPolygon(downArrowX,downArrowY,3); 
		int [] rightArrowX = 
        	{ box.x + box.width - 4 - 6,box.x + box.width - 6 - 4,box.x + box.width - 4 };
        int [] rightArrowY = 
        	{ box.y + box.height/2 - 4,box.y + box.height/2 + 4,box.y + box.height/2 };
        g.setColor(Color.blue);
        g.fillPolygon(rightArrowX,rightArrowY,3); 
        g.setColor(saved);
   	}

	static public void drawCaseTestSymbol(Graphics g,Rectangle box) {
		Color saved = g.getColor();
        g.setFont(fFont);
        FontMetrics metrics = g.getFontMetrics(fFont);
        int halfWidth = metrics.stringWidth("=")/2;
        int halfAscent = metrics.getAscent()/2;
        g.drawString("=", box.x+box.width/2 - halfWidth, box.y + halfAscent + 10);
        int [] downArrowX = 
        	{ box.x+box.width/2 - 4,box.x+box.width/2 + 4,box.x+box.width/2 }; 
        int [] downArrowY = 
        	{ box.y + box.height - 4 - 6,box.y + box.height - 4 - 6,box.y + box.height - 4};
        g.setColor(Color.red);
        g.fillPolygon(downArrowX,downArrowY,3); 
		int [] rightArrowX = 
        	{ box.x + box.width - 4 - 6,box.x + box.width - 6 - 4,box.x + box.width - 4 };
        int [] rightArrowY = 
        	{ box.y + box.height/2 - 4,box.y + box.height/2 + 4,box.y + box.height/2 };
        g.setColor(Color.blue);
        g.fillPolygon(rightArrowX,rightArrowY,3); 
        g.setColor(saved);
   	}

	static public void drawLoopTestSymbol(Graphics g,Rectangle box) {
		Color saved = g.getColor();
        int [] leftArrowX = 
        	{ box.x + 4 + 6,box.x + 4 + 6,box.x + 4 }; 
        int [] leftArrowY = 
        	{ box.y + box.height/2 - 4,box.y + box.height/2 + 4,box.y + box.height/2 };
        g.setColor(Color.red);
        g.fillPolygon(leftArrowX,leftArrowY,3); 
		int [] rightArrowX = 
        	{ box.x + box.width - 4 - 6,box.x + box.width - 6 - 4,box.x + box.width - 4 };
        g.setColor(Color.blue);
        g.fillPolygon(rightArrowX,leftArrowY,3); 
        g.setColor(saved);
        g.drawArc(box.x+box.width/2-6,box.y+8,12,12,90,300);
       	int x = box.x+box.width/2 + 1;
       	int y = box.y + 8;
        int [] arcArrowX = { x,x+1,x+7 };
        int [] arcArrowY = { y,y+7,y+1 };
        g.fillPolygon(arcArrowX,arcArrowY,3); 
   	}
  static public void drawDashedLine(Graphics g,int fromX,int fromY,
                                    int toX,int toY,int dashLen) {
    double len = Math.sqrt(Math.pow(toX-fromX,2)+Math.pow(toY-fromY,2));
    //System.err.println("len "+len);
    dashLen = (dashLen <= 0) ? 1 : dashLen;
    if (3*dashLen <= len) {
      int dX = (int)Math.floor(Math.abs(toX-fromX)/len*dashLen);
      int dY = (int)Math.floor(Math.abs(toY-fromY)/len*dashLen);
      dX = fromX < toX ? dX : -dX;
      dY = fromY < toY ? dY : -dY;
      if (dX != 0)
        while (Math.abs(toX-fromX) >= Math.abs(2*dX)) {
          //System.err.println("("+fromX+","+fromY+","+toX+","+toY+")");
          g.drawLine(fromX,fromY,fromX+dX,fromY+dY);
          fromX += 2*dX;
          fromY += 2*dY;
        }
      else if (dY != 0)
        while (Math.abs(toY-fromY) >= Math.abs(2*dY)) {   
          //System.err.println("("+fromX+","+fromY+","+toX+","+toY+")");
          g.drawLine(fromX,fromY,fromX+dX,fromY+dY);
          fromX += 2*dX;
          fromY += 2*dY;
        }
    }
    g.drawLine(fromX,fromY,toX,toY);
  }
}
