package relap.Analyzer;

import com.objectspace.jgl.*;
import relap.LanguageModel.ObjectReference;
import relap.LanguageModel.DirectReference;
import relap.LanguageModel.InDirectReference;
import java.util.Enumeration;


public class BranchingState extends InActiveState {

	protected DescendantList _descendants;


	public BranchingState(String symbol_category) {
		super(symbol_category);	
	}
	
	public BranchingState() {
		super();
	}
	
	public boolean contains(InActiveState subState) {
		boolean result = false;
		for (ArrayIterator subTree = _descendants.symbols();!subTree.atEnd();
		     subTree.advance())
		     if (subTree.get().equals(subState)) {
		     	result=true;
		     	break;
		     }
		     else 
		     	result = result || ((InActiveState)subTree.get()).contains(subState);
		return result;
	}
	
// HUOM!!   
	/* public Object dereference(ObjectReference ref) {
		if (ref.position() == -1)
        	return null;
        else
			return ((InActiveState)_descendants.at(ref.position()-1)).referencedValue(ref);
	} */
	
	public Sequence dereference(ObjectReference ref) {
		return _descendants.dereference(ref);
	}

	public DescendantList descendants() {
		return _descendants;
	}
   
	public void descendants(DescendantList desc) {
		_descendants = desc;
	}
 
 	public ParseTreeIterator start() {
 		return new ParseTreeIterator(this);
 	}
 
 	public void setAncestry(InActiveState parent) {
 		super.setAncestry(parent);
		for (ArrayIterator child=_descendants.symbols();!child.atEnd();child.advance())
			((InActiveState)child.get()).setAncestry(this);
 	
 	}
 	
	public void initCopy(ParseState new_state) {
		//System.err.println(">>>"+this);
		super.initCopy(new_state);
    	((BranchingState)new_state)
    		.descendants(new DescendantList(_descendants));
    }

	public void inversePermuteDescendants(DescendantList permutedList) {
		_descendants = new DescendantList(_productionVariant);
		int i = 1;
		for (ArrayIterator ref=_productionVariant.inversePermutation().begin();
		     !ref.atEnd();ref.advance(),i++) 
			if (_productionVariant.isRepetitive(i)) {
				if (permutedList.at(i) != null)
		     		_descendants.put(
		     			((DirectReference)ref.get()).position(),
		     			 new SList((SList)permutedList.at(i))
		     		);
		     	else
		     		_descendants.put(
		     			((DirectReference)ref.get()).position(),
		     		 	permutedList.at(i)
		     		);
		    } else
		     	_descendants.put(
		     		((DirectReference)ref.get()).position(),
		     		 permutedList.at(i)
		     	);
		  //System.err.println("permutedList: "+permutedList);
		  //System.err.println("inversPermuted: "+_descendants);
		    	
	}

	public String toString() {
        //Print the receiver on a string indenting with anInteger number of blanks.
        //Recursively print the descendants of the receiver with some more indentation."
		StringBuffer buf = new StringBuffer(super.toString());
		//buf.append(_descendants);
    	return buf.toString();
	}
 
	public String toString(int steps,int indent) {
        //Print the receiver on a string indenting with anInteger number of blanks.
        //Recursively print the descendants of the receiver with some more indentation."
		StringBuffer buf = new StringBuffer("\n");
		for (int i=1;i<=steps*indent;i++) buf.append(" ");
		buf.append(toString());
		for (ForwardIterator it=_descendants.descendants();!it.atEnd();it.advance()) 
			if (it.get() instanceof com.objectspace.jgl.SList) {
				Enumeration t = ((SList)it.get()).elements();
				while (t.hasMoreElements())
					buf.append(((InActiveState)t.nextElement()).toString(steps+1,indent));	
			}
			else
    			buf.append(((InActiveState)it.get()).toString(steps+1,indent)); 
    	return buf.toString();
    }
   
	public Object referencedValue(ObjectReference ref) {
        //Answer the input object referenced by anObjectReference which must
        //be an IndirectReference."
        if (ref.position() == -1)
        	return null;
        else
			return _attributeValues.get(((InDirectReference)ref).attribute());
	}

  	public void createSemantics() {
  		_semantics = productionVariant().production().getSemantics();
  		_semantics.initialize(this);
  	}

}