package relap.Analyzer;

import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.*;
import relap.Util.Utils;

public class CompletionAmbiguity extends Ambiguity {

	private Object index;
	private SList inclusionEquivalences;
	
	public CompletionAmbiguity(ActiveState location,Object index) {
		super(location);
		this.index = index;
		inclusionEquivalences = null;
	}
		
	public SList completionStates() { return ((ActiveState)errorLoc).completions(); }
	
	public static SList inclusionEquivalences(Sequence iStates) {
		HashSet inclusionEquivalences = new HashSet();
		Array complements = new Array();
		Copying.copy(iStates,complements);
		Sorting.sort(
			complements,
			new BinaryPredicate () {
				public boolean execute(Object state1,Object state2) {
					return ((InActiveState)state1).cover().size() <
					       ((InActiveState)state2).cover().size();
					}
			}
		);
		for (ArrayIterator cmpl=complements.begin();!cmpl.atEnd();cmpl.advance()) {
			InActiveState largestContainer = (InActiveState)cmpl.get();			
			for (int i=cmpl.index()+1;i<complements.size();i++)
				if (((InActiveState)complements.at(i)).contains((InActiveState)cmpl.get()))
					largestContainer = (InActiveState)complements.at(i);
			inclusionEquivalences.add(largestContainer);
			if (!cmpl.get().equals(largestContainer))
				inclusionEquivalences.remove(cmpl.get());
		}
		return Utils.asSList(inclusionEquivalences);
	}
		
	public Object index() {
		return index;
	}

	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("Ambiguous language structure: recognized");
		for (SListIterator state = completionStates().begin();!state.atEnd();state.advance())
			buf.append(
				"\n  "+
				((InActiveState)state.get()).productionVariant().production().description()+
				"\n"+state.get().toString()
			);
		buf.append("\n******>");
		for (SListIterator state = inclusionEquivalences(((ActiveState)errorLoc).completions()).begin();
		     !state.atEnd();state.advance())
			buf.append(
				"\n  "+
				((InActiveState)state.get()).productionVariant().production().description()+
				"\n"+state.get().toString()
			);
		buf.append("\nwhen expecting only one of them");
		buf.append("\nat: \n"+location().toString());
		return buf.toString();	
	}	
}
