package relap.Analyzer;

import relap.Util.Utils;
import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.Copying;
import java.util.Enumeration;

public class CompositeError extends ErrorDescriptor {

	private SList fSubErrors;
	
	public CompositeError(ActiveState loc,Container errors) {
		super(loc);
		fSubErrors = new SList();
		Copying.copy(errors,fSubErrors);
		setLocations();
	}

	protected void setLocations() {
		for (ForwardIterator p = fSubErrors.start();!p.atEnd();p.advance())
			((ErrorDescriptor)p.get()).setLocation(location());
	}
	
	
	public Object index() {
		return null;
	}
	
	public HashSet indices() {
		HashSet indices = new HashSet();
		Enumeration failed = unPack().elements();
		while (failed.hasMoreElements())
			Copying.copy(
				((ErrorDescriptor)failed.nextElement()).indices(),
				indices
			);
		return indices;
		
	}

	public Sequence unPack() {
		return fSubErrors;
	}
	
	public boolean isError() {
		return ((ErrorDescriptor)fSubErrors.start().get()).isError();
	}
	
	public boolean isRecoverable() {
		return ((ErrorDescriptor)fSubErrors.start().get()).isRecoverable();
	}
	
	public ActiveState incompleteParse() {
		return ((ErrorDescriptor)fSubErrors.start().get()).incompleteParse();
	}
	
	public HashSet cover() {
		HashSet myCover = super.cover();
		Enumeration failed = unPack().elements();
		while (failed.hasMoreElements())
			Copying.copy(
				((ErrorDescriptor)failed.nextElement()).cover(),
				myCover
			);
		return myCover;
	}
	
	public String toString() {
		return(
			"At:\n"+location().toString()+
		    "\nerrors:\n"+
		    Utils.contentsToString(fSubErrors,"\n")
		);
	}
}
