package relap.Analyzer;

import com.objectspace.jgl.*;
import relap.Util.Utils;

public class CoverError extends ErrorDescriptor {
	protected InActiveState _i_state;
	
	public CoverError(ActiveState state,String msg,InActiveState i_state) {
		super(state,msg);
		_i_state = i_state;
	}

	public CoverError(ActiveState state,
	                  InActiveState i_state) {
		super(state);
		_i_state = i_state;
	}
		
	public Object index() {
		return location().cover().intersection(_i_state.cover()).start().get();
	}

	public HashSet indices() {
		return location().cover().intersection(_i_state.cover());
	}
	
	public String describe() {
		StringBuffer buf = 
		new StringBuffer("these objects are part of two distinct sturctures: ");
		buf.append("\n a "+location().productionVariant().production().description());
		buf.append("\n and a "+_i_state.productionVariant().production().description());
		return buf.toString();
	}
			 
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append(
			"Objects '"+
		    Utils.contentsToString(indices())
		);
		buf.append("' belong to two distinct syntactic structures - \n");
		buf.append(location().toString()+"\nand\n");
		buf.append(_i_state.toString());
		buf.append(_message);
		return buf.toString();
	}
}
