package relap.Analyzer;

import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.Copying;

public class DeadEnd {
	ActiveState _state;
	HashSet _acc_cover;
	Object _index;
	
	public DeadEnd(ActiveState state,HashSet set) {
		_state = state;
		_acc_cover = new HashSet(set);
		_index = null;
	}
	
	public DeadEnd(ActiveState state,HashSet set,Object index) {
		_state = state;
		_acc_cover = new HashSet(set);
		_index = index;
	}
	
	public DeadEnd() {
		_state = null;
		_acc_cover = new HashSet();
		_index = null;
	}
	
	public boolean equals(Object deadEnd) {
		return 
			deadEnd instanceof DeadEnd &&
			((DeadEnd)deadEnd).state().surrogate().equals(state().surrogate());
	}
	
	public int hashCode() {
		return state().surrogate().intValue();
	}	
	
	public void addToCover(HashSet set) {
		Copying.copy(set,_acc_cover);
	}
	
	public HashSet accCover() { return _acc_cover; }
	
	public void index(Object object) { _index = object; }
	
	public Object index() { return _index; }
	
	public String toString() {
		StringBuffer buf = new StringBuffer();
		if (_state.errorDescription() != null)
			buf.append(_state.errorDescription().toString());
		else
		    buf.append("at "+index().toString()+":");
		buf.append("\n"+_state.toString()+"\n"+_acc_cover.toString());
		return buf.toString();
	}
	
	public ActiveState state() { return _state; }
	
}
