package relap.Analyzer;
import com.objectspace.jgl.*;
import relap.Editor.ErrorInterpreter;
import relap.LanguageModel.Verifiable;
import relap.Editor.ProcessingError;

abstract public class ErrorDescriptor
	implements ProcessingError {
		
	protected ParseState errorLoc;
	protected String _message;
	
	public ErrorDescriptor(ParseState state) {
		errorLoc = state;
		_message = "";
	}

	public ErrorDescriptor(ParseState state,String msg) {
		errorLoc = state;
		_message = msg;
	}
	
	public ErrorDescriptor(ActiveState state) {
		errorLoc = state;
		_message = "";
	}

	public ErrorDescriptor(ActiveState state,String msg) {
		errorLoc = state;
		_message = msg;
	}
	
	public Verifiable getFailedCondition() {
		return null;
	}
	
	public HashSet cover() {
		return errorLoc.cover();
	}

	abstract public Object index();

	public HashSet indices() {
		HashSet set = new HashSet();
		set.add(index());
		return set;
	}
	
	public boolean isError() {
		return true;
	}
	
	public boolean isRecoverable() {
		return true;
	}
	
	public ParseState location() {
		return errorLoc;
	} 
	
	public void setLocation(ParseState loc) {
		errorLoc = loc;
	} 
	
	public void message(String msg) {
		_message = msg;
	}

	public String message() {
		return _message;
	}
	
	public String describe() {
		if (!message().equals(""))
			return message();
		else
			return getClass().getName();
	}

	public String describeWith(String msg) {
		return 
			msg+describe();
	}

	public String describeWith(ErrorInterpreter interpreter) {
		return describe();
	}
	
	public Sequence unPack() {
		SList subErrors = new SList();
		subErrors.pushBack(this);
		return subErrors;
	}

/* 	public BranchingState patchedState(ParseTable parseTable,ARGRecognizer parser)
	throws QueryException {
		return null;
	}
 */	
	public ActiveState incompleteParse(){
		return (ActiveState)location();
	}	
}
	