package relap.Analyzer;

import com.objectspace.jgl.Pair;
import com.objectspace.jgl.HashSet;
import com.objectspace.jgl.Array;
import relap.Util.Utils;
import relap.LanguageModel.ExistenceConstraint;

public class ExistenceFailureData
	implements FailureData {

	private Pair fData;
	private String fCount;
	private HashSet fTerminals;
	private ExistenceConstraint fXConstraint;
	
	public ExistenceFailureData(Pair objects,ExistenceConstraint constraint) {
		fData = objects;
		fCount = "a";
		fTerminals = new HashSet();
		fXConstraint = constraint;
	}
	
	public ExistenceFailureData(Pair objects,String count,HashSet terminals,ExistenceConstraint constraint) {
		fData = objects;
		fCount = count;
		fTerminals = new HashSet(terminals);
		fXConstraint = constraint;
	}
	
	public HashSet objects() {
		HashSet dataSet = new HashSet((HashSet)fData.second);
		dataSet.add(fData.first);
		return dataSet;
	}

	public Object getBoundArgument() {
		return fData.first;
	}
	
	public HashSet getQueryResult() {
		return new HashSet((HashSet)fData.second);
	}
		
	public ExistenceConstraint getConstraint() {
		return fXConstraint;
	}
	
	public String toString() {
		return fCount+" "+fData.toString();
	}

	public Array tuple() {
		return new Array();
	}
	
	public String count() {
		return fCount;
	}
	
	public HashSet terminals() {
		return new HashSet(fTerminals);
	}
}