package relap.Analyzer;

import com.objectspace.jgl.HashSet;
import com.objectspace.jgl.Container;
import com.objectspace.jgl.Array;
import com.objectspace.jgl.algorithms.Copying;
import relap.LanguageModel.ExpanderRelation;
import relap.LanguageModel.Tuple;
import relap.Editor.ExplicitExpanderRelation;
import java.util.Enumeration;
import relap.LanguageModel.Verifiable;

public class ExtraRelations extends AdvancementError {

	ExpanderRelation relation;
	HashSet indices;
	Container expectedKinds;
	int expectedCount;
	int pos;
	String kind;
	Verifiable failedCond;
	
	public ExtraRelations(ActiveState state,InActiveState i_state,
	                        String msg,Object input_object,String kind,HashSet objects,
	                        ExpanderRelation relation,int pos,int expectedCount,
			    			Container expected,Verifiable failed) {
		super(state,i_state,msg,input_object);
		indices = new HashSet();
		if (relation instanceof ExplicitExpanderRelation) {
			Enumeration object = objects.elements();
			while (object.hasMoreElements()) {
				Array tupleData = new Array(2);
				tupleData.put(pos,object.nextElement());
				tupleData.put((pos+1)%2,input_object);
				indices.add(
					((ExplicitExpanderRelation)relation)
						.getFigure(
							new Tuple(tupleData,relation)
						)
				);
			}
		} else
			Copying.copy(objects,indices);
		this.relation = relation;
		this.pos = pos;
		this.expectedCount = expectedCount;
		expectedKinds = expected; 
		this.kind = kind;
		failedCond = failed;
	}

	public Verifiable getFailedCondition() {
		return failedCond;
	}

	public boolean isError() {
		return true;
	}

	public boolean isRecoverable() {
		return false;
	}
	
	public HashSet indices() { return indices; }
	
	
	public String describe() {
		return 
			relation.describeExtras(expectedKinds,_index,expectedCount,pos,kind)
			+"\nto recognize a "
			+((ActiveState)errorLoc).productionVariant().production().description();
	}
	
}
