package relap.Analyzer;

import relap.Util.Utils;
import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.Copying;
import java.util.Enumeration;

public class FailedPredicates extends ErrorDescriptor {

	private SList _failures;
	
	public FailedPredicates(ActiveState loc,SList predicates) {
		super(loc);
		_failures = predicates;
		setLocations();
	}

	protected void setLocations() {
		for (ForwardIterator p = _failures.start();!p.atEnd();p.advance())
			((PredicateEvaluationError)p.get()).setLocation(location());
	}
	
	
	public Object index() {
		return null;
	}


	public Sequence unPack() {
		return _failures;
	}
	
	public HashSet cover() {
		HashSet myCover = super.cover();
		Enumeration failed = unPack().elements();
		while (failed.hasMoreElements())
			Copying.copy(
				((ErrorDescriptor)failed.nextElement()).cover(),
				myCover
			);
		return myCover;
	}
	
	public String toString() {
		return(
			"At:\n"+location().toString()+
		    "\npredicates failed:\n"+
		    Utils.contentsToString(_failures,"\n")
		);
	}

  public SList failures() {
    return new SList (_failures);
  }
}
