package relap.Analyzer;

import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.Copying;

public class GrammarAmbiguity extends Ambiguity {
	private SList parseTrees;
	
	public GrammarAmbiguity(ActiveState location,Container trees) {
		super(location);
		parseTrees = new SList();
		Copying.copy(trees,parseTrees);
	}
		
	public SList parseTrees() { return parseTrees; }
	
	public Object index() {
		return ((InActiveState)parseTrees.front()).cover().start().get();
	}
		
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("Ambiguous grammar: parsed");
		for (SListIterator state = parseTrees().begin();!state.atEnd();state.advance())
			buf.append(
				"\n  "+
				((InActiveState)state.get()).productionVariant().production().description()+
				"\n"+state.get().toString()
			);
		buf.append("\nwhen expecting only one of them");
		return buf.toString();	
	}	
}
