package relap.Analyzer;

import relap.LanguageModel.ObjectReference;
import com.objectspace.jgl.Sequence;

public class LeafState 
	extends InActiveState {

	public LeafState(String category) {
		super(category);
	}

	public boolean contains(InActiveState subState) {
		return false;
	}

	public Sequence dereference(ObjectReference ref) {
		return null;
	}
	
	public Object inputObject() {
		return cover().begin().get();
	}
  
	public String toString(int steps,int indent) {
		StringBuffer buf = new StringBuffer("\n");
		for (int i=1;i<=steps*indent;i++) buf.append(" ");
		buf.append(toString());
    	return buf.toString();
    }
 
 
	public Object referencedValue(ObjectReference ref) {
        if (ref.position() == -1)
        	return null;
        else
			return inputObject();
	}

  	public void createSemantics(ARGRecognizer parser) {
  		_semantics = parser.getGrammar().getDefaultLeafSemantics();
  		((LeafNode)_semantics).initialize(this);
  		_semantics.setDescription(parser.getInput().describeTerminal(category()));
  	}

}
