package relap.Analyzer;

import com.objectspace.jgl.SList;
import com.objectspace.jgl.ForwardIterator;

public class MiddleNode implements SyntaxTreeNode {

	private BranchingState fParseState;
	private SList fDescendants;
	private String fDescription;

	public MiddleNode() {
		fParseState = null;
		fDescendants = null;
		fDescription = null;
	}
	
	public void initialize(InActiveState state) {
		fParseState = (BranchingState)state;
		fDescription = state.productionVariant().production().description();
		ForwardIterator desc = ((BranchingState)state).descendants().descendants();
		SList list = new SList();
		while (!desc.atEnd()) {
			if (desc.get() instanceof SList) {
				SList temp = new SList();
				for (ForwardIterator iState = ((SList)desc.get()).start();
				     !iState.atEnd();iState.advance())
					temp.pushBack(((InActiveState)iState.get()).getSemantics());
				list.pushBack(temp);
			}
			else
				list.pushBack(((InActiveState)desc.get()).getSemantics());
			desc.advance();
		}
		setDescendants(list);
	}
	
	public void setDescendants(SList list) {
		fDescendants = new SList(list);
	}
	
	public SList getDescendants() {
		return fDescendants;
	}
	
	public Object getDescendantAt(int pos) 
		throws IndexOutOfBoundsException {
		return fDescendants.at(pos);
	}
	
	public Object getOptionalDescendantAt(int pos)
		throws IndexOutOfBoundsException {
		Object child = getDescendantAt(pos);
		if (child instanceof EmptyNode)
			return null;
		if (child instanceof SList) {
			SList desc = (SList)child;
			if (desc.size() == 1 && desc.front() instanceof EmptyNode)
				return null;
		}
		return child;
	}
	
	public void setDescription(String description) {
		fDescription = description;
	}

	public String getDescription() {
		return fDescription;
	}
	
	public SyntaxTreeIterator start() {
		return new MiddleNodeIterator(this);
	}
	
	public Object valueOfAttribute(String attribute) {
		return fParseState.valueOfAttribute(attribute);
	}
}