package relap.Analyzer;

import com.objectspace.jgl.HashSet;
import relap.LanguageModel.ExpanderRelation;
import relap.LanguageModel.Relation;
import relap.LanguageModel.Verifiable;

public class MissingRelationTuple extends AdvancementError {

	protected HashSet fExpectedObjects;
	protected int fAtPos;
	protected String fBoundArgumentKind;
	protected Relation fRelation;
	protected Verifiable failedCond;
	
	public MissingRelationTuple(ActiveState state,InActiveState i_state,
	                        String msg,Object input_object,String kind,HashSet expected,
	                        int atPos,Relation relation, Verifiable failed) {
		super(state,i_state,msg,input_object);
		fExpectedObjects = expected;
		fAtPos = atPos;
		fBoundArgumentKind = kind;
		fRelation = relation;
		failedCond = failed;
	}

	public Verifiable getFailedCondition() {
		return failedCond;
	}

	public String describe() {
		return
			((ExpanderRelation)fRelation)
				.describeMissingTuple(
					fExpectedObjects,index(),fAtPos,fBoundArgumentKind
				)
			+"\nto recognize a "
			+((ActiveState)errorLoc).productionVariant().production().description();
	}

}
