package relap.Analyzer;


import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.Copying;

public class MultiFailure extends Failure {

	private SList failures;
	
	public MultiFailure() {
		super();
		failures = new SList();
	}
	
	public MultiFailure(String msg) {
		super(msg);
		failures = new SList();
	}

	public void addFailure(Failure f) {
		failures.pushBack(f);
	}
	
	public SList subFailures() {
		return failures;
	}

	public Container errorDescriptors() {
		HashSet descriptors = new HashSet();
		for (SListIterator f=failures.begin();!f.atEnd();f.advance())
			Copying.copy(
				((Failure)f.get()).errorDescriptors(),
			    descriptors
			);
		return descriptors;
	}
}
