package relap.Analyzer;

import com.objectspace.jgl.SList;
import com.objectspace.jgl.SListIterator;
import com.objectspace.jgl.BinaryPredicate;
import com.objectspace.jgl.algorithms.Copying;
import com.objectspace.jgl.algorithms.Finding;
import com.objectspace.jgl.predicates.BindFirstPredicate;
import com.objectspace.jgl.HashSet;


public class ParsePath {

	protected SList path;
	
	public ParsePath() {
		path = new SList();
	}
	
	public ParsePath(ParsePath otherPath) {
		path = new SList();
		Copying.copy(otherPath.path(),path);
	}
	
	protected SList path() {
		return path;
	}
	
	protected class EqualSurrogate implements BinaryPredicate {
		public boolean execute(Object state,Object pathState) {
			return
				((ActiveState)state).surrogate().equals(((ActiveState)pathState).surrogate());
		}
	}
	
	public boolean contains(ActiveState state) {
		return 
			!Finding.findIf(
				path,
				new BindFirstPredicate(new EqualSurrogate(),state)
			).atEnd();
	}
	
	public void push(ActiveState state) {
		path.pushBack(state);
	}
	
	public Object pop() {
		return path.popBack();
	}
	
	public String toString() {
		StringBuffer buf = new StringBuffer();
		
		for (SListIterator it=path.begin();!it.atEnd();it.advance())
			buf.append("<"+((ActiveState)it.get()).surrogate().toString()+"> "+it.get().toString()+"\n");
	
		return buf.toString();
	}
	
	public HashSet pathCover() {
		HashSet cover = new HashSet();
		for (SListIterator it=path.begin();!it.atEnd();it.advance())
			Copying.copy(((ActiveState)it.get()).cover(),cover);
		return cover;
	}
}
