package relap.Analyzer;

import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.*;
import com.objectspace.jgl.adapters.*;
import java.io.*;
import java.util.*;

abstract public class ParseResult 
	implements ProcessingResult {

	private boolean _success;
	
	public ParseResult(boolean success) {
		_success = success;
	} 

	public Container errorDescriptors() {
		return new HashSet();
	}
	
	public Container parseTrees() {
		return new HashSet();
	}

	abstract public void reportOn(PrintWriter log);
	
	
	public boolean success() {
		return _success;
	}
	
	public Vector errors() {
		Vector v = new Vector();
		Copying.copy(errorDescriptors(),new VectorArray(v));
		return v;
	}
	
	public Vector warnings() {
		return new Vector();
	}
	
	public Object product() {
		return parseTrees();
	}
	
	public String toString() {
		StringWriter buf = new StringWriter();
		reportOn(new PrintWriter(buf));
		return buf.toString();
	}
}