package relap.Analyzer;

import com.objectspace.jgl.*;

public class ParseTreeIterator {

	BranchingState fCurrentRoot;
	InActiveState fCurrentNode;
	ForwardIterator fChild;
	Stack fStates;
	
	
	public ParseTreeIterator(InActiveState root) {
		fStates = new Stack();
		newRoot((BranchingState)root);
	}
	
	protected void newRoot(BranchingState newRoot) {
		if (fCurrentRoot != null) 
			fStates.push(new Pair(fCurrentRoot,fChild));
		fCurrentRoot = (BranchingState)newRoot;
		fCurrentNode = fCurrentRoot;
		fChild = fCurrentRoot.descendants().flatRep().start();
	}

	protected boolean restoreRoot() {
		if (fStates.isEmpty())
			return false;
		Pair oldState = (Pair)fStates.pop();
		fCurrentRoot = (BranchingState)oldState.first;
		fChild = (ForwardIterator)oldState.second;
		return true;
	}

	public boolean atEnd() {
		return fCurrentNode == null;
	}
	
	public InActiveState current() {
		return fCurrentNode;
	}
	
	public void advance() {
		if (!fChild.atEnd()) {
			fCurrentNode = (InActiveState)fChild.get();
			fChild.advance();
			if (fCurrentNode instanceof BranchingState)
				newRoot((BranchingState)fCurrentNode);
		}
		else if (restoreRoot())
			advance();
		else
			fCurrentNode = null;
	}
}
		
