package relap.Analyzer;

import relap.Util.DiGraphNode;
import relap.Util.Utils;
import com.objectspace.jgl.Sequence;

public class ProductionDependency extends DiGraphNode {

	private Sequence variants;
	private String nonTerminal;
	private String attribute;
	
	public ProductionDependency(Sequence variants,String nonTerminal,
	                            String attribute) {
		this.variants = variants;
		this.nonTerminal = nonTerminal;
		this.attribute = attribute;
	} 
	
	public Sequence variants() {
		return variants;
	}
	
	public String nonTerminal() {
		return nonTerminal;
	}

	public String attribute() {
		return attribute;
	}
	
	public String toString() {
		return nonTerminal+"."+attribute+Utils.contentsToString(variants,"\n");
	}

	public boolean equals(Object otherObject) {
		return 
			otherObject instanceof ProductionDependency
			&&
			((ProductionDependency)otherObject).nonTerminal().equals(nonTerminal)
			&&
			((ProductionDependency)otherObject).attribute().equals(attribute);
	}
	
	public int hashCode() {
		return nonTerminal.hashCode();
	}
}
