package relap.Analyzer;
import relap.Util.Utils;
import com.objectspace.jgl.*;
import relap.LanguageModel.Verifiable;

public class ScanningError extends ErrorDescriptor {
	protected Object _input_object;
	protected String expectedTerminal;
	protected Verifiable lexMatch;
	
	public ScanningError(ActiveState state,String msg,Object input_object,
	                     Verifiable match) {
		super(state,msg);
		_input_object = input_object;
		expectedTerminal = ((ActiveState)errorLoc).symbolAtDot();
		lexMatch = match;
	}

	public ScanningError(ActiveState state,Object input_object,String expected,
	                     Verifiable match) {
		super(state);
		_input_object = input_object;
		expectedTerminal = expected;
		lexMatch = match;
	}
	
	public Verifiable getFailedCondition() {
		return lexMatch;
	}
	
	public Object index() {
		return _input_object;
	}
	
	public boolean isRecoverable() {
		return true;
	}

	public String describe() {
		return 
			"expecting "+expectedTerminal+" to parse a "+
			((ActiveState)errorLoc).productionVariant().production().description();
	}

	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("at "+_input_object.toString()+": expecting ");
		buf.append(((ActiveState)errorLoc).symbolAtDot());
		return buf.toString();
	}
}
