package relap.Analyzer;

import relap.Util.Utils;
import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.Copying;
import java.io.*;

public class SingleFailure extends Failure {

	private Container _errorDescriptors;
	
	public SingleFailure(Container descriptors) {
		super();
		_errorDescriptors = descriptors;
	} 

	public SingleFailure(Container descriptors,String msg) {
		super(msg);
		_errorDescriptors = descriptors;
	} 

	public SingleFailure(String msg) {
		super();
		_errorDescriptors = new SList();
	} 

	public void addErrors(Container errors) {
		Copying.copy(errors,_errorDescriptors);
	}

	public void addError(ErrorDescriptor error) {
		_errorDescriptors.add(error);
	}

	public Container errorDescriptors() {
		return _errorDescriptors;
	}
}
