package relap.Editor;

import com.objectspace.jgl.*;
import java.util.Enumeration;

public abstract class AbstractObjectToInputGeneratorMap 
	implements ObjectToInputGeneratorMap {
	
	private HashMap map;
	
	public AbstractObjectToInputGeneratorMap() {	
		map = new HashMap(true);
		createMap();
	}
	
	protected HashMap getMap() {
		return map;
	}

	abstract protected void createMap(); //  fill the map in a concrete subclass
	
	public InputGenerator mapObjectToGenerator(Object object) {
		String name = object.getClass().getName(); 
		InputGenerator g =
			(InputGenerator)map.get(
				name.substring(name.lastIndexOf('.')+1)
			);
		if (g != null)
			return g;
		else
			return getDefaultGenerator(); 
	}

	protected InputGenerator getDefaultGenerator() {
		return new InputGenerator() {
			public void generate(Object target,InputGenerationState state) {
				state.input.addObject(target);
				state.input.setTerminalType(
					target,state.symbols.mapObjectToSymbol(target)
				);
			}
		};
	}
		
	public String toString() {
		return map.toString();
	}
}