package relap.Editor;

import com.objectspace.jgl.*;
import java.util.Enumeration;

public abstract class AbstractObjectToSymbolMap 
	implements ObjectToSymbolMap {
	
	protected HashMap map;
	protected HashMap descriptions;
	
	
	protected void createMap() { 

		map = new HashMap(true);
		descriptions = new HashMap();
		fill();
	}
	
	// hook; use add in subclasses to populate the map
	abstract protected void fill(); 
	
	public Object add(String editorClass,String symbolClass,String description) {
		descriptions.add(symbolClass,description);
		return map.add(editorClass,symbolClass);
	}
	
	public Object add(String editorClass,String symbolClass) {
		descriptions.add(symbolClass,symbolClass);
		return map.add(editorClass,symbolClass);
	}
	
	public String mapObjectToSymbol(Object object) {
		if (map==null) createMap();
		String name = object.getClass().getName();
		return (String)map.get(name.substring(name.lastIndexOf('.')+1));
	}

	public String describeObject(Object object) {
		if (map==null) createMap();
		String name = object.getClass().getName();
		String symbol = (String)map.get(name.substring(name.lastIndexOf('.')+1));
		if (symbol != null) 
			return describeSymbol(symbol);
		else
			return null;
	}
	
	public String describeSymbol(String symbolClass) {
		if (map==null) createMap();
		return (String)descriptions.get(symbolClass);
	}
	
	public Enumeration mapSymbolToObject(String symbol) {
		if (map==null) createMap();
		return map.keys(symbol);
	}
	
	public String toString() {
		return map.toString();
	}
}