package relap.Editor;

import com.objectspace.jgl.*;
import java.util.Enumeration;

public abstract class AbstractObjectToVisitorMap 
	implements ObjectToVisitorMap {
	
	private HashMap map;
	
	public AbstractObjectToVisitorMap() {	
		map = new HashMap(true);
		createMap();
	}
	
	protected HashMap getMap() {
		return map;
	}

	abstract protected void createMap(); //  fill the map in a concrete subclass
	
	public DynamicVisitor mapObjectToVisitor(Object object) {
		String name = object.getClass().getName(); 
		DynamicVisitor v =
			(DynamicVisitor)map.get(
				name.substring(name.lastIndexOf('.')+1)
			);
		if (v != null)
			return v;
		else
			return getDefaultVisitor(); 
	}

	abstract protected DynamicVisitor getDefaultVisitor();
		
	public String toString() {
		return map.toString();
	}
}