package relap.Editor;

import relap.Analyzer.*;
import relap.LanguageModel.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import java.io.*;
import java.util.Date;
import java.util.Enumeration;
import java.awt.*;
import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.*;
import com.objectspace.jgl.predicates.*;

public interface Analyzer extends ErrorInterpreter {
	
	public Drawing getDrawing();
	
	public void setEditor(DrawingEditor d);
	
	public DrawingEditor getEditor();
	
	public void visitDrawing(Object visitorState,ObjectToVisitorMap visitors)
		throws VisitorException;

	public void analyzeDrawing();
	                        
	public SyntaxTreeNode getSemantics();
	
	public void setSemantics(SyntaxTreeNode node);
	
	public SemanticProcessor getSemanticProcessor();
	
	public ARGRecognizer getParser();
	
	public void setLogging(boolean mode);
	
	public void register(RelapObserver o);
	
	public void unregister(RelapObserver o);

	public void setSelection(com.objectspace.jgl.Container objects);
	
	public void highlightSelection();
	
	public void clearSelection();
}