package relap.Editor;

import CH.ifa.draw.framework.Figure;
import CH.ifa.draw.standard.CompositeFigure;
import CH.ifa.draw.framework.FigureEnumeration;
import relap.Editor.Standard.DynamicVisitor;
import relap.Editor.Standard.VisitorException;
import relap.Editor.Standard.InputGenerationState;
import relap.Editor.Figures.EllipseNode;
import com.objectspace.jgl.Array;
import com.objectspace.jgl.SList;
import relap.LanguageModel.Tuple;
import relap.LanguageModel.InvalidTupleException;

public class ContainmentToRelationExcluding 
	extends ContainmentToRelationMapper {

	SList classesToExclude;
		
	public ContainmentToRelationExcluding(String relationName,String excludeClass) {
		this(relationName,new SList(1,excludeClass));
	}
	
	public ContainmentToRelationExcluding(String relationName) {
		this(relationName,new SList());
	}

	public ContainmentToRelationExcluding(String relationName,SList excludeClasses) {
		super(relationName);
		classesToExclude = new SList(excludeClasses);
	}

	public void visit(Object figure,Object visitorState)
		throws VisitorException {
		InputGenerationState state = (InputGenerationState)visitorState;
		state.setVisited(figure);
		state.input.addObject(figure);
		state.input.setTerminalType(
			figure,state.symbols.mapObjectToSymbol(figure)
		);
		FigureEnumeration children = ((CompositeFigure)figure).figures();
		while (children.hasMoreElements()) {
			Figure child = children.nextFigure();
			String name = child.getClass().getName(); 
			try {
				if (!classesToExclude.contains(name.substring(name.lastIndexOf('.')+1))) {
					Array tuple = new Array(2);
					tuple.put(0,child);
					tuple.put(1,figure);
					state.addImplicitRelationTuple(getRelationName(),tuple);
				}
				state.dispatchVisit(child);
			} catch (InvalidTupleException e) { 
				throw new VisitorException(e.getMessage());
			}
			catch (NoSuchRelationException e) {
				throw new VisitorException(e.getMessage());
			}
		}
	}
}