package relap.Editor;

import CH.ifa.draw.framework.Figure;
import CH.ifa.draw.standard.CompositeFigure;
import CH.ifa.draw.framework.FigureEnumeration;
import com.objectspace.jgl.Array;
import com.objectspace.jgl.SList;
import relap.LanguageModel.Tuple;
import relap.LanguageModel.InvalidTupleException;

public class ContainmentToRelationMapper
	implements DynamicVisitor {

	protected String fRelationName;
	protected SList classesToExclude;
		
	public ContainmentToRelationMapper(String relationName,String excludeClass) {
		this(relationName,new SList(1,excludeClass));
	}
	
	public ContainmentToRelationMapper(String relationName) {
		this(relationName,new SList());
	}

	public ContainmentToRelationMapper(String relationName,SList excludeClasses) {
		fRelationName = relationName;
		classesToExclude = new SList(excludeClasses);
	}

	
	protected String getRelationName() {
		return fRelationName;
	}
	
	
	public void visit(Object figure,Object visitorState)
		throws VisitorException {
		InputGenerationState state = (InputGenerationState)visitorState;
		state.setVisited(figure);
		state.input.addObject(figure);
		state.input.setTerminalType(
			figure,state.symbols.mapObjectToSymbol(figure)
		);
		FigureEnumeration children = ((CompositeFigure)figure).figures();
		while (children.hasMoreElements()) {
			Figure child = children.nextFigure();
			String name = child.getClass().getName(); 
			try {
				if (!classesToExclude.contains(name.substring(name.lastIndexOf('.')+1))) {
					Array tuple = new Array(2);
					tuple.put(0,child);
					tuple.put(1,figure);
					state.addImplicitRelationTuple(getRelationName(),tuple);
				}
				state.dispatchVisit(child);
			} catch (InvalidTupleException e) { 
				throw new VisitorException(e.getMessage());
			}
			catch (NoSuchRelationException e) {
				throw new VisitorException(e.getMessage());
			}
		}
		/*****
		while (children.hasMoreElements()) {
			Figure child = children.nextFigure();
			Array tuple = new Array(2);
			tuple.put(0,child);
			tuple.put(1,figure);
			try {
				state.addImplicitRelationTuple(getRelationName(),tuple);
				state.dispatchVisit(child);
			} catch (InvalidTupleException e) { 
				throw new VisitorException(e.getMessage());
			}
			catch (NoSuchRelationException e) {
				throw new VisitorException(e.getMessage());
			}
		}
		*****/
	}
}