package relap.Editor;

import relap.LanguageModel.InvalidTupleException;
import relap.LanguageModel.ExpanderRelation;
import relap.LanguageModel.Tuple;
import relap.Analyzer.IndexedMDSet;
import relap.Analyzer.FailureData;
import com.objectspace.jgl.HashMap;
import com.objectspace.jgl.Container;
import com.objectspace.jgl.HashSet;
import relap.Util.Utils;
import com.objectspace.jgl.Array;
import CH.ifa.draw.framework.Figure;

public class ExplicitExpanderRelation extends ExpanderRelation {

	protected HashMap fTupleToFigure;
	protected String fRelationObjectDescription;
	protected String fFromLeftDescription;
	protected String fFromRightDescription;

	public ExplicitExpanderRelation(String name,String relObject,
									String left,String right) {
		super(name);
		fTupleToFigure = new HashMap();
		fRelationObjectDescription = relObject;
		fFromLeftDescription = left;
		fFromRightDescription = right;
	}
	
	public void addTuple(Array tuple,Figure figure) 
		throws InvalidTupleException {
		fTupleToFigure.put(addTuple(tuple),figure);
	}
	
	public Figure getFigure(Tuple tuple) {
		return (Figure)fTupleToFigure.get(tuple);
	}
	
	public String describeInvalidTuple(Tuple tuple) {
		return "invalid "+fRelationObjectDescription;
	}
	
	public String describeInvalidTuple(Array tuple) {
		return "invalid "+fRelationObjectDescription;
	}
	
	public String describeExtraTuple(Tuple tuple) {
		return "extra "+fRelationObjectDescription;
	}
	
	public String describeExtraTuple(Array tuple) {
		return "extra "+fRelationObjectDescription;
	}
	
	public String describeMissingTuple(HashSet expectedObjects,Object object,
	                                   int pos,String kind) {
		if (pos == 1) 
			return
				"expecting a "+fRelationObjectDescription+" "+
				fFromLeftDescription+" this "+kind+" and "+
				fFromRightDescription+" a "+
				Utils.listContents(expectedObjects,", "," or ");
			
		else 
			return
				"expecting a "+fRelationObjectDescription+" "+
				fFromRightDescription+" this "+kind+" and "+
				fFromLeftDescription+" a "+
				Utils.listContents(expectedObjects,", "," or ");	
	}
	
	public String describeMissingTuple() {
		return "expecting a "+fRelationObjectDescription+" between these objects";
	}
	
	public String describeFailure(FailureData data,IndexedMDSet input) {
		return 
			"expecting "+data.count()+" "+fRelationObjectDescription+" "+
			fFromLeftDescription+" the "+
			input.describeTerminal(input.getTerminalType(data.tuple().at(0)))+" and "+
		    fFromRightDescription+" the "+
			input.describeTerminal(input.getTerminalType(data.tuple().at(1)));
	}
	
	public String describeExtras(Container expectedObjects,Object object,
	                             int expectedCount, int pos,String kind) {
		return "expecting only "+expectedCount+" "+fRelationObjectDescription;
	}

}