package relap.Editor;

import relap.Analyzer.IndexedMDSet;
import com.objectspace.jgl.HashSet;
import com.objectspace.jgl.Array;
import CH.ifa.draw.framework.Figure;
import relap.LanguageModel.InvalidTupleException;

public class InputGenerationState implements VisitorState {

	public IndexedMDSet input;
	public ObjectToVisitorMap generators;
	public ObjectToSymbolMap symbols;
	public HashSet visited; 
	
	public InputGenerationState(ObjectToVisitorMap generators,
								ObjectToSymbolMap symbols) {
		this.generators = generators;
		this.symbols = symbols;
		input = new IndexedMDSet();
		visited = new HashSet();
	}
	
	public void dispatchVisit(Object target) 
		throws VisitorException {
		if (visited.get(target) == null)
			generators.mapObjectToVisitor(target).visit(target,this);
	}
	
	public void setVisited(Object visitedObject) {
		visited.add(visitedObject);
	}
	
	public void addExplicitRelationTuple(String relationName,Array tupleData,
	                                     Figure connectionFigure)
		throws InvalidTupleException,
		       NoSuchRelationException {
		//System.err.println(tupleData);
		ExplicitExpanderRelation relation = 
			(ExplicitExpanderRelation)input.getRelation(relationName);
		if (relation==null)
			throw(new NoSuchRelationException(relationName));
		relation.addTuple(tupleData,connectionFigure);
		input.setTerminalType(
			tupleData.at(0),
			symbols.mapObjectToSymbol((Figure)tupleData.at(0))
		);
		input.setTerminalType(
			tupleData.at(1),
			symbols.mapObjectToSymbol((Figure)tupleData.at(1))
		);
	}

	public void addImplicitRelationTuple(String relationName,Array tupleData)
		throws InvalidTupleException,
		       NoSuchRelationException {
		//System.err.println(tupleData);
		ImplicitExpanderRelation relation = 
			(ImplicitExpanderRelation)input.getRelation(relationName);
		if (relation==null)
			throw(new NoSuchRelationException(relationName));
		relation.addTuple(tupleData);
		input.setTerminalType(
			tupleData.at(0),
			symbols.mapObjectToSymbol((Figure)tupleData.at(0))
		);
	}
}