package relap.Editor;

import com.objectspace.jgl.Array;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.framework.Figure;
import relap.LanguageModel.InvalidTupleException;

public class LineConnectionToRelation
	implements DynamicVisitor {
	
	protected String fRelationName;
	
	protected String getRelationName() {
		return fRelationName;
	}
	
	public LineConnectionToRelation(String relationName) {
		fRelationName = relationName;
	}
	
	public void visit(Object target,Object visitorState)
		throws VisitorException {
		InputGenerationState state = (InputGenerationState)visitorState;
		state.setVisited(target);
		Array tuple = new Array(2);
		LineConnection conn = (LineConnection)target;
		tuple.put(0,conn.start().owner());
		tuple.put(1,conn.end().owner());
		try {
			if (conn.start() instanceof SemanticConnector)
				state.addExplicitRelationTuple(
					(String)((SemanticConnector)conn.start()).getSemantics(),
					tuple,
					(Figure)target
				);
			else
				state.addExplicitRelationTuple(getRelationName(),tuple,(Figure)target);
			state.dispatchVisit(tuple.at(0));
			state.dispatchVisit(tuple.at(1));
		} 
		catch (InvalidTupleException e) {
			throw new VisitorException(e.getMessage());
		}
		catch (NoSuchRelationException e) {
			throw new VisitorException(e.getMessage());
		}
	}
}