package relap.Editor;


import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Enumeration;
import relap.Analyzer.*;
import com.objectspace.jgl.HashSet;
import com.objectspace.jgl.HashMap;
import CH.ifa.draw.framework.Figure;
import CH.ifa.draw.figures.PolyLineFigure;
import CH.ifa.draw.framework.DrawingEditor;

public class ParseSuccessPanel extends Panel implements ActionListener {    
    private TextArea textArea;
    Button firstButton;
    Button nextButton;
    ParseTreeIterator currentTree;
    BranchingState parseTreeRoot;
    Analyzer analyzer;

    public ParseSuccessPanel(Analyzer analyzer,ParseResult result) {
        super();
        this.analyzer = analyzer;
        setLayout(new BorderLayout());
        Label label = new Label("Recognized structure:");
        add("North",label);
        parseTreeRoot = (BranchingState)result.parseTrees().start().get();
		currentTree = parseTreeRoot.start();
       textArea = new TextArea(10, 40);
        textArea.setEditable(false);
        add("Center", textArea);
        //Create bottom row.
        Panel p2 = new Panel();
        firstButton = new Button("First");
        firstButton.addActionListener(this);
        p2.add(firstButton);
        nextButton = new Button("Next");
        nextButton.addActionListener(this);
        p2.add(nextButton);
        add("South", p2);
        update();
   }
    
   protected void update() {
    if (!currentTree.atEnd()) {
    	InActiveState current = currentTree.current();
    	cleanUp();
    	analyzer.setSelection(current.cover());
    		//System.err.println(current);
      String newline = System.getProperty("line.separator");
      try {
        BufferedReader content;
        if (current instanceof BranchingState)
          content =
        		new BufferedReader(
        			new StringReader(
        				current.productionVariant().production().toString()
        			)
        		);
        else
        	content =
        		new BufferedReader(new StringReader(current.category()));
        			
        String line = content.readLine();
        while (line != null) {
        	textArea.append(line+newline);
        	line = content.readLine();
        }
      } catch (IOException e) {
        System.err.println(e);
        textArea.append("Failed to read parse tree info from "+current+newline);
      }
    } else
    	nextButton.setEnabled(false);
   }

   public void actionPerformed(ActionEvent event) {
    	Object source = event.getSource();
    	if (source == firstButton) {
        nextButton.setEnabled(true);
				currentTree = parseTreeRoot.start();
				update();
		} else if (source == nextButton) {
			currentTree.advance();
			update();
		}
  }
	
	public void cleanUp() {
			//System.err.println("!!!!!!!! cleaning up");
    	textArea.setText("");
    	analyzer.clearSelection();
	}

}