package relap.Editor;

import relap.Analyzer.*;
import relap.LanguageModel.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import java.io.*;
import java.util.Date;
import java.util.Enumeration;
import java.awt.event.*;
import java.awt.*;
import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.*;
import com.objectspace.jgl.predicates.*;

public class RelapAnalysisView 
	extends Dialog implements RelapObserver {
	
	protected Analyzer fAnalyzer;
	protected Frame parent;
  Component attachedTo;
  ComponentAdapter compAdapter, thisAdapter;
  			
	public RelapAnalysisView(Frame editorFrame,
												Analyzer analyzer,String title) {
		super(editorFrame,title,false);
		parent = editorFrame;
		fAnalyzer = analyzer;
		analyzer.register(this);
	}
	
	public void attachTo(Component comp) {
		attachedTo = comp;
		attachedTo.addComponentListener(getAttacheeListener());
		addComponentListener(getThisListener());
		setPosition();
	}
	
	private ComponentAdapter getAttacheeListener() {
		if (compAdapter == null)
			compAdapter = 
				new ComponentAdapter() {
					public void componentResized(ComponentEvent e) {
						if (e.getSource() == attachedTo) 
							setPosition();
					}
					public void componentMoved(ComponentEvent e) {
						if (e.getSource() == attachedTo) 
							setPosition();
					}
				};
		return compAdapter;
	}
	
	private ComponentAdapter getThisListener() {
		if (thisAdapter == null)
			thisAdapter = 
				new ComponentAdapter() {
					public void componentResized(ComponentEvent e) {
						if (e.getSource() == RelapAnalysisView.this) 
							setPosition();
					}
					public void componentMoved(ComponentEvent e) {
						if (e.getSource() == RelapAnalysisView.this) 
							setPosition();
					}
				};
		return thisAdapter;
	}
			
	public void detach() {
		if (attachedTo != null)
			attachedTo.removeComponentListener(getAttacheeListener());
		removeComponentListener(getThisListener());
		attachedTo = null;
	}
	
	private void setPosition() {
		if (attachedTo != null) {
			Point loc = attachedTo.getLocation();
			loc.translate(attachedTo.getSize().width,0);
			setLocation(loc);
		}
	}
		
	
	public void update(RelapEvent e) {
		// hook
	}

	public Analyzer getAnalyzer() {
		return fAnalyzer;
	}
}