package relap.Editor;

import CH.ifa.draw.application.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;

public abstract class RelapApp extends DrawApplication {

	protected Window fAnalyzerView;
	
	public RelapApp(String title) {
		super(title);
	}

	public void setAnalyzerView(Window aw) {
		fAnalyzerView = aw;
	}
	
	public Window getAnalyzerView() {
		return fAnalyzerView;
	}
	
	abstract protected Window createAnalyzerView();	
	
	public void open() {
		super.open();
		fAnalyzerView = createAnalyzerView();
	}
	
	protected void createMenus(MenuBar mb) {
		super.createMenus(mb);
		mb.add(createAnalyzeMenu());
  }

  protected Menu createAnalyzeMenu() {
		Menu menu = new Menu("Analyzer");
		MenuItem mi = new MenuItem("Open Analyzer");
		mi.addActionListener(
		    new ActionListener() {
		        public void actionPerformed(ActionEvent event) {
		            fAnalyzerView.setVisible(true);
		            Point p = getLocation();
		            p.translate(getSize().width,0);
		            fAnalyzerView.setLocation(p);
		        }
		    }
		);
		menu.add(mi);
		/*
		mi = new MenuItem("Show Semantics");
		mi.addActionListener(
		    new ActionListener() {
		        public void actionPerformed(ActionEvent event) {
		        	((RelapDrawingView)view()).showSemantics();
		        }
		    }
		);
		menu.add(mi);
		*/ 
		return menu;
	}

}