package relap.LanguageModel;

import com.objectspace.jgl.Array;
import com.objectspace.jgl.ArrayIterator;
import com.objectspace.jgl.Stack;
import com.objectspace.jgl.predicates.BindFirstPredicate;
import com.objectspace.jgl.predicates.NotIdenticalTo;
import com.objectspace.jgl.algorithms.Filtering;

public class ARGRhsOrderingStrategy extends RhsOrderingStrategy {


	public ARGRhsOrderingStrategy(RelationalGrammarImplementation grammar,
								  GrammarProduction production) {
		super(grammar,production);
	}
	
	public Array orderingVariants() throws RhsOrderingException {
    	Array variants = new Array(); 
    	Stack stack;
    	Array rest;
    	Array objRefs = new Array();
    	
    	for (int i=1;i<=_production.rhs().size();i++) 
    		objRefs.add(new DirectReference(_production,i));
    	for (ArrayIterator refs = objRefs.begin();!refs.atEnd();refs.advance()) {   
 	       stack = new Stack();
 	       stack.push(refs.get());
 	       rest = 
        	(Array)Filtering.select(objRefs,
   	     							new BindFirstPredicate(new NotIdenticalTo(),
        												   refs.get()));
    	    if (!findOrder(stack,rest))
        		throw(new RhsOrderingException(_production,
       	 								 	   ((DirectReference)refs.get()).position()));
        	variants.add((new OrderingVariant(_production)).permute(stack));
   		}
		return variants;
	}
}
