package relap.LanguageModel;

public class DirectReference extends ObjectReference {
	public DirectReference(GrammarProduction production,int position) {
		super(production,position);
	}
	
	public ObjectReference copy() { 
		return new DirectReference(production(),position());
	}
	
	public void checkRhsReference(RelationalGrammarImplementation grammar) 
		throws InvalidObjectReferenceException {
		if (position() < 1 || position() > production().rhs().size())
			throw(new InvalidObjectReferenceException(this,
						"reference to a rhs element out of bounds"));
		String symbol = (String)(production().rhs().at(position()-1));
		if (!grammar.isTerminal(symbol))
			throw(new InvalidObjectReferenceException(this,
						"symbol at position "+Integer.toString(position())+
						" is not a terminal"));		
	}	
			
	public void checkLhsReference(RelationalGrammarImplementation grammar) 
		throws InvalidObjectReferenceException {
		throw(new InvalidObjectReferenceException(this,
					"reference to an attribute of the lhs non-terminal expected"));
	}

	public boolean isInDirectReference() { return false; }

}
