package relap.LanguageModel;

abstract public class ObjectReference {

	private int _position;
	private GrammarProduction _production;
	
	public ObjectReference(GrammarProduction production,int position) {
		_position = position;
		_production = production;
	}
 
 	abstract public ObjectReference copy();
 	
	abstract public void checkRhsReference(RelationalGrammarImplementation grammar) 
		throws InvalidObjectReferenceException;

	abstract public void checkLhsReference(RelationalGrammarImplementation grammar) 
		throws InvalidObjectReferenceException;

	abstract public boolean isInDirectReference();
	
	public GrammarProduction production() { return _production; }
	public int position() { return _position; }
	public void position(int pos) { _position = pos; }
	public String toString() { return "#"+Integer.toString(_position); }
}