package relap.LanguageModel;

import com.objectspace.jgl.Array;
import com.objectspace.jgl.ArrayIterator;
import com.objectspace.jgl.Stack;
import com.objectspace.jgl.Pair;
import com.objectspace.jgl.ForwardIterator;
import java.util.Enumeration;
import java.io.*;

abstract public class RhsOrderingStrategy {

	protected RelationalGrammarImplementation _grammar;
	protected GrammarProduction _production;

	public RhsOrderingStrategy(RelationalGrammarImplementation grammar,
							GrammarProduction production) {
		_grammar = grammar;
		_production = production;
	}
	
	abstract public Array orderingVariants() throws RhsOrderingException ;


/*
        "Answer true if anOrderedCollection is empty. Else take a member from
        anOrderedCollection, check if it is in some relation to any member in the stack,
        and if so, push it onto stack, and recursively findOrder for the rest of
        anOrderedCollection. Do this until the recursion return with true or until all members
        of anOrderedCollection have been tried and return false. This method implements
        a backtracking algorithm."

*/
	protected boolean findOrder(Stack stack,Array rest) {
		boolean success,found;
		
		if (rest.isEmpty())
			success = true;
		else {
			success = false;
			int i = 0;
			while (i < rest.size() && !success) {
				Array local_rest = new Array(rest);
				ObjectReference o_ref = (ObjectReference)local_rest.at(i);
				found = false;
				for (ArrayIterator companions = 
						((Array)_production.cNet().at(o_ref.position()-1)).begin();
					 !companions.atEnd();companions.advance()) {
					 if (!found)
					 	for (ForwardIterator items = stack.start();
					 		 !items.atEnd();items.advance())
					 		 if (((ObjectReference)items.get()).position() ==
					 		 	 ((Integer)((Pair)companions.get()).first).intValue())
					 			found = true;
				}
				if (found) {
				 	stack.push(o_ref);
				 	local_rest.remove(i);
				 	success = findOrder(stack,local_rest);
				 	if (!success)
				 		stack.pop();
				}
				i++;
			}
		}
		return success;
	}
}
