package relap.LanguageModel;

import com.objectspace.jgl.*;
import com.objectspace.jgl.Stack;
import com.objectspace.jgl.predicates.BindFirstPredicate;
import com.objectspace.jgl.predicates.NotIdenticalTo;
import com.objectspace.jgl.algorithms.Filtering;
import java.util.Vector;
import java.util.Enumeration;

public class RhsOrderingWithOptionals extends ARGRhsOrderingStrategy {


	public RhsOrderingWithOptionals(RelationalGrammarImplementation grammar,
								  GrammarProduction production) {
		super(grammar,production);
	}
	
	Vector currentPick;
	
	public Array orderingVariants() throws RhsOrderingException {
    /*	Array variants = new Array(); 
    	Stack stack;
    	Array rest;
    	Array objRefs = new Array();
    	
    	for (int i=1;i<=_production.rhs().size();i++) 
    		objRefs.add(new DirectReference(_production,i));
    	for (ArrayIterator refs = objRefs.begin();!refs.atEnd();refs.advance()) {   
 	       stack = new Stack();
 	       stack.push(refs.get());
 	       rest = 
        	(Array)Filtering.select(objRefs,
   	     							new BindFirstPredicate(new NotIdenticalTo(),
        												   refs.get()));
    	    if (!findOrder(stack,rest))
        		throw(new RhsOrderingException(_production,
       	 								 	   ((DirectReference)refs.get()).position()));
        	variants.add((new OrderingVariant(_production)).permute(stack));
   		} */
   	Array variants = super.orderingVariants();
   	
   //	System.err.println("============");
   //	System.err.println(_production);
   	Picker picker = new Picker(_production);
   	currentPick = picker.pickNext();
   	while (!currentPick.isEmpty()) {
   		//System.err.println(">>>===* "+currentPick);
			Stack stack;
    	Array rest;
    	Array objRefs = new Array();
    	
    	for (int i=1;i<=_production.rhs().size();i++) 
    		if (notInPick(i))
    			objRefs.add(new DirectReference(_production,i));
    	for (ArrayIterator refs = objRefs.begin();!refs.atEnd();refs.advance()) {   
 	       stack = new Stack();
 	       stack.push(refs.get());
 	       rest = 
        	(Array)Filtering.select(objRefs,
   	     							new BindFirstPredicate(new NotIdenticalTo(),
        												   refs.get()));
    	   if (!findOrder(stack,rest))
        	throw(new RhsOrderingException(_production,currentPick));
    	}	
   		currentPick = picker.pickNext();
   	}
		return variants;
	}
	
	protected boolean notInPick(int i) {
		Enumeration picked = currentPick.elements();
		while (picked.hasMoreElements())
			if (i == ((Integer)picked.nextElement()).intValue())
				return false;
		return true;	
	}
	
	/*protected boolean findOrder(Stack stack,Array rest) {
		boolean success,found;
		
		if (rest.isEmpty())
			success = true;
		else {
			success = false;
			int i = 0;
			while (i < rest.size() && !success) {
				Array local_rest = new Array(rest);
				ObjectReference o_ref = (ObjectReference)local_rest.at(i);
				found = false;
				for (ArrayIterator companions = 
						((Array)_production.cNet().at(o_ref.position()-1)).begin();
					 !companions.atEnd();companions.advance()) {
					 if (!found)
					 	for (ForwardIterator items = stack.start();
					 		 !items.atEnd();items.advance())
					 		 if (((ObjectReference)items.get()).position() ==
					 		 	 ((Integer)((Pair)companions.get()).first).intValue())
					 			found = true;
				}
				if (found) {
				 	stack.push(o_ref);
				 	local_rest.remove(i);
				 	success = findOrder(stack,local_rest);
				 	if (!success)
				 		stack.pop();
				}
				i++;
			}
		}
		return success;
	}*/

	
	class Picker {
		int pickPos;
		GrammarProduction production;
		int pickSize;
		int maxPick;
		int rhsLength;
		int pickablesRemaining[];
		
		
		protected Picker(GrammarProduction production) {
			this.production = production;
			pickPos = 1;
			pickSize = 1;
			maxPick = 0;
			rhsLength = production.sequenceLength();
			for (int i = 1;i<=rhsLength;i++)
				if (production.isOptional(i))
					maxPick++;
			pickablesRemaining = new int[rhsLength];
			int remaining = maxPick;
			for (int i=0;i<rhsLength;i++) {
				if (production.isOptional(i+1))
					remaining--;
				pickablesRemaining[i] = remaining;
			}
		}
			
		protected Vector pickNext() {
			while (pickSize <= maxPick) {
				while (pickPos <= rhsLength && !production.isOptional(pickPos))
					pickPos++;
				if (pickPos > rhsLength || (pickablesRemaining[pickPos-1] < pickSize-1)) {
					pickSize++;
					pickPos = 1;
				} 
				else
					break;
			}
			if (pickSize > maxPick)
				return new Vector();
			Vector pick = new Vector();
			pick.addElement(new Integer(pickPos));
			int nextPos = pickPos;
			for (int i = 2;i<=pickSize;i++) {
				nextPos++;
				while (nextPos <= rhsLength && !production.isOptional(nextPos))  
					nextPos++;
				if (nextPos > rhsLength) {
					System.err.println("nextPos out of bounds in pickNext");
					return new Vector();
				}
				pick.addElement(new Integer(nextPos));
			}
			pickPos++;
			return pick;
		}
	}		
}