package relap.LanguageModel;

import com.objectspace.jgl.Array;

public class Tuple {

	private Array dataObjects;
	private boolean mark;
	private Relation relation;
	
	public Tuple(Array data,Relation relation){
		dataObjects = data;
		mark = false;
		this.relation = relation;
	}

	public void markTuple() {
		mark = true;
	}

	public void unMarkTuple() {
		mark = false;
	}
	
	public boolean isMarked() {
		return mark;
	}
	
	public Array data() {
		return dataObjects;
	}
	
	public Relation relation() {
		return relation;
	}
	
	public boolean equals(Object anotherTuple) {
	    if (!(anotherTuple instanceof Tuple))
	    	return false;
	    if (!(((Tuple)anotherTuple).relation() == relation))
	    	return false;
	    if (!dataObjects.equals(((Tuple)anotherTuple).data()))
	    	return false;
	    return true;
	}
	
	public int hashCode() {
		return dataObjects.hashCode();
	}
		
	public String toString() {
		if (mark)
			return dataObjects.toString()+" X";
		return dataObjects.toString();
	}
}
