package relap.Util;

import com.objectspace.jgl.DList;
import com.objectspace.jgl.ForwardIterator;
import com.objectspace.jgl.algorithms.Copying;

public class DirectedGraphNodeImpl implements DirectedGraphNode {

	private DList fInEdges;
	private DList fOutEdges;
	
	public DirectedGraphNodeImpl() {
		fInEdges = new DList();
		fOutEdges = new DList();
	}

 	public Edge addOutEdge(Edge edge) {
 		if (!fOutEdges.contains(edge))
 			fOutEdges.pushBack(edge);
 		return edge;
 	}
	
 	public Edge addInEdge(Edge edge) {
 		if (!fInEdges.contains(edge))
 			fInEdges.pushBack(edge);
 		return edge;
 	}

	public ForwardIterator getOutEdges() {
		return fOutEdges.start();
	}

	public ForwardIterator getInEdges() {
		return fInEdges.start();
	}

 	public Edge addEdge(Edge edge) {
 		if (edge instanceof DiGraphEdge) {
 			if (((DiGraphEdge)edge).getStart() == this)
 				return addInEdge(edge);
 			if (((DiGraphEdge)edge).getEnd() == this)
 				return addOutEdge(edge);
 		}
 		return null;
 	}
	
 	public Edge changeEdge(Edge oldEdge,Edge newEdge) {
 		int count = fInEdges.replace(oldEdge,newEdge);
 		count += fOutEdges.replace(oldEdge,newEdge);
 		if (count>0)
 			return newEdge;
 		return null;
 	}
	
	public Edge removeEdge(Edge edge) {
 		int count = fInEdges.remove(edge);
 		count += fOutEdges.remove(edge);
 		if (count>0)
 			return edge;
 		return null;
	
	}
	
	public ForwardIterator getEdges() {
		DList allEdges = new DList(fInEdges);
		Copying.copy(fOutEdges,allEdges);
		return allEdges.start();
	}
}
