package relap.Util;

import java.awt.*;
import java.awt.event.*;

public class PromptUser extends Dialog implements ActionListener {
	
	protected Button cancelButton;
	protected Button okButton;
	protected TextField msg;
	protected String input;

	
	public PromptUser(Frame f,String title,String prompt,String answer) {
		super(f,title,true);
		setLayout(new BorderLayout());
		Panel p1 = new Panel();
		p1.setLayout(new FlowLayout());
		Label l = new Label(prompt);
		p1.add(l);
		msg = new TextField(answer,40);
		p1.add(msg);
		add("North",p1);
		Panel p2 = new Panel();
		okButton = new Button("    Ok    ");
		okButton.addActionListener(this);
		cancelButton = new Button("Cancel");
		cancelButton.addActionListener(this);
		p2.add(okButton);
		p2.add(cancelButton);
		add("South",p2);
		input = null;
		pack();
	}
	
	public PromptUser(Frame f,String title,String prompt) {
		this(f,title,prompt,"");
	}

	public void actionPerformed(ActionEvent event) {
		if (event.getSource() == okButton) {
			if (msg.getText().equals(""))
				input = null;
			else
				input = msg.getText();
		}
		else if (event.getSource() == cancelButton)
			input = null;
		setVisible(false);
	}
	
	public String getInput() {
		return input;
	}
}
		
		
		
	
	