package relap.Util;


import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.Copying;
import java.util.*;

public class Utils {

	public static final String contentsToString(Container c) {
		return contentsToString(c," ");	
	}
	
	public static final String contentsToString(Container c,String sep) {
		StringBuffer buf = new StringBuffer("");
		
		for (Enumeration elts = c.elements();elts.hasMoreElements();)
			buf.append(sep+elts.nextElement().toString());

		return buf.toString();
	}
	
	public static final String listContents(Container c,String sep,String lastSep) {
		StringBuffer buf = new StringBuffer("");
		int pos = 1;
		for (Enumeration elts = c.elements();elts.hasMoreElements();pos++) 
		{
			String item = elts.nextElement().toString();
			if (pos == 1)
				buf.append(item);
			if (pos > 1 && elts.hasMoreElements()) 
				buf.append(sep+item);
			else
				if (pos > 1)
					buf.append(lastSep+item);
		}
		return buf.toString();
	}
	
  	public static HashSet asHashSet( Container c ) {
  		return (HashSet)asContainer( c, new HashSet() );
  	}

  	public static Array asArray( Container c ) {
    	return (Array)asContainer( c, new Array() );
    }

  	public static SList asSList( Container c ) {
    	return (SList)asContainer( c, new SList() );
    }

  	public static DList asDList( Container c ) {
    	return (DList)asContainer( c, new DList() );
    }

  	private static Container asContainer( Container orig, Container copy ) {
    	Copying.copy( orig, copy );
    	return copy;
    }

  	public static Container enumerationAsContainer( Enumeration e ) {
  		SList elems = new SList();
    	for (;e.hasMoreElements();)
    		elems.pushBack(e.nextElement());
    	return elems;
    }
    
    public static SList cartesianProduct(Array arguments) {
		SList product = new SList();
		Array tuple;
		for (ArrayIterator arg = arguments.begin();!arg.atEnd();arg.advance()) 
			if (arg.index()==0) 
				for (ForwardIterator object = ((Sequence)arg.get()).start();
				     !object.atEnd();object.advance()) {
					tuple = new Array(arguments.size());
					tuple.put(arg.index(),object.get()); 
				    product.pushBack(tuple);
				}
			else {
				SList prevTuples = product;
				product = new SList();
				for (ForwardIterator object = ((Sequence)arg.get()).start();
				     !object.atEnd();object.advance()) 
				    for (ForwardIterator t = prevTuples.start();!t.atEnd();
				         t.advance()) { 
						tuple = new Array((Array)t.get());
						tuple.put(arg.index(),object.get()); 
				    	product.pushBack(tuple);
					}
			} 
		return product;
	}
	
	public static int joinSize(Array arguments) {
		int size = 1;
		for (ArrayIterator arg = arguments.begin();!arg.atEnd();arg.advance()) 
			size *= ((Sequence)arg.get()).size();
		return size;
	} 

}	
		
		
